#include <stddef.h>
#include "PWM.h"

static void _end_cycle(PWM_rtl_t *_g) {
  _g->_sd_reset.active=0;
  _g->_sd_reset.event=0;
  _g->_sd_reset.last_active++;
  _g->_sd_reset.last_event++;
  _g->_sd_sclk.active=0;
  _g->_sd_sclk.event=0;
  _g->_sd_sclk.last_active++;
  _g->_sd_sclk.last_event++;
  _g->_sd_clk.active=0;
  _g->_sd_clk.event=0;
  _g->_sd_clk.last_active++;
  _g->_sd_clk.last_event++;
  _g->_sd_p_pwm_stream_rdy.active=0;
  _g->_sd_p_pwm_stream_rdy.event=0;
  _g->_sd_p_pwm_stream_rdy.last_active++;
  _g->_sd_p_pwm_stream_rdy.last_event++;
  _g->_sd_p_pwm_stream_en.active=0;
  _g->_sd_p_pwm_stream_en.event=0;
  _g->_sd_p_pwm_stream_en.last_active++;
  _g->_sd_p_pwm_stream_en.last_event++;
  _g->_sd_p_pwm_stream_eos.active=0;
  _g->_sd_p_pwm_stream_eos.event=0;
  _g->_sd_p_pwm_stream_eos.last_active++;
  _g->_sd_p_pwm_stream_eos.last_event++;
  _g->_sd_p_pwm_stream_data.active=0;
  _g->_sd_p_pwm_stream_data.event=0;
  _g->_sd_p_pwm_stream_data.last_active++;
  _g->_sd_p_pwm_stream_data.last_event++;
  _g->_sd_p_iteration_stream_rdy.active=0;
  _g->_sd_p_iteration_stream_rdy.event=0;
  _g->_sd_p_iteration_stream_rdy.last_active++;
  _g->_sd_p_iteration_stream_rdy.last_event++;
  _g->_sd_p_iteration_stream_en.active=0;
  _g->_sd_p_iteration_stream_en.event=0;
  _g->_sd_p_iteration_stream_en.last_active++;
  _g->_sd_p_iteration_stream_en.last_event++;
  _g->_sd_p_iteration_stream_eos.active=0;
  _g->_sd_p_iteration_stream_eos.event=0;
  _g->_sd_p_iteration_stream_eos.last_active++;
  _g->_sd_p_iteration_stream_eos.last_event++;
  _g->_sd_p_iteration_stream_data.active=0;
  _g->_sd_p_iteration_stream_data.event=0;
  _g->_sd_p_iteration_stream_data.last_active++;
  _g->_sd_p_iteration_stream_data.last_event++;
  _g->_sd_p_dna_stream_rdy.active=0;
  _g->_sd_p_dna_stream_rdy.event=0;
  _g->_sd_p_dna_stream_rdy.last_active++;
  _g->_sd_p_dna_stream_rdy.last_event++;
  _g->_sd_p_dna_stream_en.active=0;
  _g->_sd_p_dna_stream_en.event=0;
  _g->_sd_p_dna_stream_en.last_active++;
  _g->_sd_p_dna_stream_en.last_event++;
  _g->_sd_p_dna_stream_eos.active=0;
  _g->_sd_p_dna_stream_eos.event=0;
  _g->_sd_p_dna_stream_eos.last_active++;
  _g->_sd_p_dna_stream_eos.last_event++;
  _g->_sd_p_dna_stream_data.active=0;
  _g->_sd_p_dna_stream_data.event=0;
  _g->_sd_p_dna_stream_data.last_active++;
  _g->_sd_p_dna_stream_data.last_event++;
  _g->_sd_p_counter_stream_rdy.active=0;
  _g->_sd_p_counter_stream_rdy.event=0;
  _g->_sd_p_counter_stream_rdy.last_active++;
  _g->_sd_p_counter_stream_rdy.last_event++;
  _g->_sd_p_counter_stream_en.active=0;
  _g->_sd_p_counter_stream_en.event=0;
  _g->_sd_p_counter_stream_en.last_active++;
  _g->_sd_p_counter_stream_en.last_event++;
  _g->_sd_p_counter_stream_eos.active=0;
  _g->_sd_p_counter_stream_eos.event=0;
  _g->_sd_p_counter_stream_eos.last_active++;
  _g->_sd_p_counter_stream_eos.last_event++;
  _g->_sd_p_counter_stream_data.active=0;
  _g->_sd_p_counter_stream_data.event=0;
  _g->_sd_p_counter_stream_data.last_active++;
  _g->_sd_p_counter_stream_data.last_event++;
  _g->_sd_p_sum_stream_rdy.active=0;
  _g->_sd_p_sum_stream_rdy.event=0;
  _g->_sd_p_sum_stream_rdy.last_active++;
  _g->_sd_p_sum_stream_rdy.last_event++;
  _g->_sd_p_sum_stream_en.active=0;
  _g->_sd_p_sum_stream_en.event=0;
  _g->_sd_p_sum_stream_en.last_active++;
  _g->_sd_p_sum_stream_en.last_event++;
  _g->_sd_p_sum_stream_eos.active=0;
  _g->_sd_p_sum_stream_eos.event=0;
  _g->_sd_p_sum_stream_eos.last_active++;
  _g->_sd_p_sum_stream_eos.last_event++;
  _g->_sd_p_sum_stream_data.active=0;
  _g->_sd_p_sum_stream_data.event=0;
  _g->_sd_p_sum_stream_data.last_active++;
  _g->_sd_p_sum_stream_data.last_event++;
}

static void clk_delta(PWM_rtl_t *_g)

{

  if (BIT(_g->s_b10_predicates,5-0) == 1) {
    _g->t_1=_g->ni435_suif_tmp8;
  } else  {
    _g->t_1=_g->r_suif_tmp8;
  }
  _g->_tmp1_16=1;
  while (_g->_tmp1_16) {
    _g->_tmp1_15=_g->t_1;
    if (BIT(_g->s_b10_predicates,3-0) == 1) {
      _g->t_2=_g->ni432_suif_tmp7;
    } else  {
      _g->t_2=_g->r_suif_tmp7;
    }
    _g->_tmp1_14=1;
    while (_g->_tmp1_14) {
      _g->_tmp1_13=_g->t_2;
      if (BIT(_g->s_b10_predicates,1-0) == 1) {
        _g->t_3=_g->ni429_suif_tmp6;
      } else  {
        _g->t_3=_g->r_suif_tmp6;
      }
      _g->_tmp1_12=1;
      while (_g->_tmp1_12) {
        _g->_tmp1_11=_g->t_3;
        if (BIT(_g->t_1,0-0) == 1) {
          _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),6-0);
        } else  {
          _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
        }
        _g->_tmp1_10=1;
        while (_g->_tmp1_10) {
          _g->_tmp1_9=_g->s_b10_predicates;
          if ((!BIT(_g->t_3,0-0)) == 1) {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),3-0);
          } else  {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
          }
          _g->_tmp1_8=1;
          while (_g->_tmp1_8) {
            _g->_tmp1_7=_g->s_b10_predicates;
            if ((!BIT(_g->t_1,0-0)) == 1) {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),7-0);
            } else  {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) 0,7-0);
            }
            _g->_tmp1_6=1;
            while (_g->_tmp1_6) {
              _g->_tmp1_5=_g->s_b10_predicates;
              if (BIT(_g->t_3,0-0) == 1) {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),2-0);
              } else  {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
              }
              _g->_tmp1_4=1;
              while (_g->_tmp1_4) {
                _g->_tmp1_3=_g->s_b10_predicates;
                if (BIT(_g->t_2,0-0) == 1) {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),4-0);
                } else  {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
                }
                _g->_tmp1_2=1;
                while (_g->_tmp1_2) {
                  _g->_tmp1=_g->s_b10_predicates;
                  _g->p_sequence_dout2=_g->ram_5_mem[(_g->ram_5_raddr2)-0];
                  if (_g->newState == 1) {
                    _g->p_sequence_imm2=_g->p_sequence_dout2;
                  } else  {
                    _g->p_sequence_imm2=_g->r2_sequence;
                  }
                  _g->ni168_sequence=_g->p_sequence_imm2;
                  _g->ni425_suif_tmp_0=sign_ext(_g->ni168_sequence,32);
                  _g->ni426_suif_tmp5=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x41));
                  if (BIT(_g->ni426_suif_tmp5,0-0) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) 1,0-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
                  }
                  if ((!BIT(_g->ni426_suif_tmp5,0-0)) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) 1,1-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
                  }
                  if ((!BIT(_g->t_2,0-0)) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),5-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
                  }
                  if (BIT(_g->t_2,0-0) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),4-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
                  }
                  _g->_tmp1_2=(int ) (_g->_tmp1 != _g->s_b10_predicates);
                }
                if (BIT(_g->t_3,0-0) == 1) {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),2-0);
                } else  {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
                }
                _g->_tmp1_4=(int ) (_g->_tmp1_3 != _g->s_b10_predicates);
              }
              if ((!BIT(_g->t_1,0-0)) == 1) {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),7-0);
              } else  {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) 0,7-0);
              }
              _g->_tmp1_6=(int ) (_g->_tmp1_5 != _g->s_b10_predicates);
            }
            if ((!BIT(_g->t_3,0-0)) == 1) {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),3-0);
            } else  {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
            }
            _g->_tmp1_8=(int ) (_g->_tmp1_7 != _g->s_b10_predicates);
          }
          if (BIT(_g->t_1,0-0) == 1) {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),6-0);
          } else  {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
          }
          _g->_tmp1_10=(int ) (_g->_tmp1_9 != _g->s_b10_predicates);
        }
        _g->ni429_suif_tmp6=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x43));
        if (BIT(_g->s_b10_predicates,1-0) == 1) {
          _g->t_3=_g->ni429_suif_tmp6;
        } else  {
          _g->t_3=_g->r_suif_tmp6;
        }
        _g->_tmp1_12=_g->_tmp1_11 != _g->t_3;
      }
      _g->ni432_suif_tmp7=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x47));
      if (BIT(_g->s_b10_predicates,3-0) == 1) {
        _g->t_2=_g->ni432_suif_tmp7;
      } else  {
        _g->t_2=_g->r_suif_tmp7;
      }
      _g->_tmp1_14=_g->_tmp1_13 != _g->t_2;
    }
    _g->ni435_suif_tmp8=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x54));
    if (BIT(_g->s_b10_predicates,5-0) == 1) {
      _g->t_1=_g->ni435_suif_tmp8;
    } else  {
      _g->t_1=_g->r_suif_tmp8;
    }
    _g->_tmp1_16=_g->_tmp1_15 != _g->t_1;
  }
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,5-0),5-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,4-0),4-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,3-0),3-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,2-0),2-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,1-0),1-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,0-0),0-0);
  if ((_g->s_b10_vstall & _g->s_b10_stage) == 0x0) {
    _g->s_b10_stall=0;
  } else  {
    _g->s_b10_stall=1;
  }
  if ((_g->fadd_ll_0_queue_in_ptr) < 3) {
    _g->fadd_ll_0_queue_next_ptr=(((_g->fadd_ll_0_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_0_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_1_queue_in_ptr) < 3) {
    _g->fadd_ll_1_queue_next_ptr=(((_g->fadd_ll_1_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_1_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_2_queue_in_ptr) < 3) {
    _g->fadd_ll_2_queue_next_ptr=(((_g->fadd_ll_2_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_2_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_3_queue_in_ptr) < 3) {
    _g->fadd_ll_3_queue_next_ptr=(((_g->fadd_ll_3_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_3_queue_next_ptr=0x0;
  }
  _g->p_pwm_dout=_g->ram_4_mem[(_g->ram_4_raddr)-0];
  _g->p_pwm_dout2=_g->ram_4_mem[(_g->ram_4_raddr2)-0];
  _g->fadd_ll_3_queue_out_ptr=_g->fadd_ll_3_queue_next_ptr;
  _g->fadd_ll_2_queue_out_ptr=_g->fadd_ll_2_queue_next_ptr;
  _g->fadd_ll_1_queue_out_ptr=_g->fadd_ll_1_queue_next_ptr;
  _g->fadd_ll_0_queue_out_ptr=_g->fadd_ll_0_queue_next_ptr;
  if (((BIT(_g->s_b10_stage,6-0) & (!BIT(_g->s_b10_vstall,6-0))) & (!BIT(_g->s_b10_5.f_suif_tmp4,0-0))) == 1) {
    _g->s_b10_loop=0;
  } else  {
    _g->s_b10_loop=1;
  }
  if (_g->s_b10_stall == 0 && _g->s_b10_vcont == 0x0) {
    _g->s_b10_flushed=1;
  } else  {
    _g->s_b10_flushed=0;
  }
  if (_g->newState == 1) {
    _g->p_pwm_imm2=_g->p_pwm_dout2;
  } else  {
    _g->p_pwm_imm2=_g->r2_pwm;
  }
  if (_g->newState == 1) {
    _g->p_pwm_imm=_g->p_pwm_dout;
  } else  {
    _g->p_pwm_imm=_g->r_pwm;
  }
  _g->ni445_counter=((_g->r_counter + 0x1)&0xffff);
  switch (_g->s_b10_state) {
  case pipeStateType_init:
    _g->s_b10_done=0;
    break;
  case pipeStateType_run:
    _g->s_b10_done=(!_g->s_b10_loop);
    break;
  case pipeStateType_flush:
    _g->s_b10_done=_g->s_b10_flushed;
    break;
  default:
    _g->s_b10_done=0;
    break;
  }
  _g->t_4=_g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_out_ptr)-0];
  _g->t_5=_g->fadd_ll_1_queue_mem[(_g->fadd_ll_1_queue_out_ptr)-0];
  _g->t_6=_g->fadd_ll_2_queue_mem[(_g->fadd_ll_2_queue_out_ptr)-0];
  _g->t_7=_g->fadd_ll_3_queue_mem[(_g->fadd_ll_3_queue_out_ptr)-0];
  if (_g->thisState == stateType_b2s1 && _g->p_pwm_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s0 && _g->p_iteration_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b6s1 && _g->p_dna_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b10s0 && _g->s_b10_done == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b11s0 && ((_g->p_counter_stream_rdy & _g->p_sum_stream_rdy) & _g->p_dna_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b15s0 && ((((_g->p_pwm_stream_eos & _g->p_iteration_stream_eos) & _g->p_dna_stream_eos) & _g->p_counter_stream_rdy) & _g->p_sum_stream_rdy) == 0) {
    _g->stateEn=0;
  } else  {
    _g->stateEn=1;
  }
  _g->ni406_suif_tmp9=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_j),SIGN32(0x8),int));
  _g->ni408_suif_tmp10=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_i),SIGN32(0x4),int));
  _g->ni409_nSamplePwm=_g->r_pwm_stream;
  _g->ni416_suif_tmp11=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_k),SIGN32(0x8),int));
  _g->ni417_nSampleDna=_g->r_dna_stream;
  _g->ni421_suif_tmp0=(((unsigned int)0x0<<1)|(unsigned int)LESS_EQ_SIGN(SIGN32(0x0),SIGN32(((sign_ext_2(_g->r_dnaLength,32) - 0x8))),int));
  _g->ni423_suif_tmp3=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->ni422_l),SIGN32(0x8),int));
  _g->ni170_r_e_g_1=(((((_g->r_l)>>(0-0))&0x1ff) + (((_g->r_suif_tmp90)>>(0-0))&0x1ff))&0x1ff);
  _g->ni438_l=_g->s_b10_0.f_r_e_g_2;
  _g->ni428_r_e_g_0=(((_g->r_l)>>(0-0))&0x1f);
  _g->ni431_r_e_g_3=((0x8 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni196_pwm=_g->p_pwm_imm2;
  _g->ni207_pwm=_g->p_pwm_imm;
  _g->ni218_pwm=_g->p_pwm_imm2;
  _g->ni229_pwm=_g->p_pwm_imm;
  _g->ni427_sum=_g->t_4;
  _g->ni430_sum=_g->t_5;
  _g->ni433_sum=_g->t_6;
  _g->ni436_sum=_g->t_7;
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,0-0),0-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,1-0),1-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,2-0),2-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,3-0),3-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,4-0),4-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,5-0),5-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,6-0),6-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
  }
  _g->ni447_suif_tmp1=(((unsigned int)0x0<<1)|(unsigned int)LESS_EQ_SIGN(SIGN32(sign_ext_2(_g->ni445_counter,32)),SIGN32(((sign_ext_2(_g->r_dnaLength,32) - 0x8))),int));
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,6-0) == 1) {
    _g->ti227_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti227_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,4-0) == 1) {
    _g->ti216_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti216_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,2-0) == 1) {
    _g->ti205_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti205_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,0-0) == 1) {
    _g->ti194_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti194_pipeen=0;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_din=_g->ni417_nSampleDna;
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_din=_g->r_nSampleDna;
  } else  {
    _g->p_sequence_din=0x0;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_we=1;
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_we=1;
  } else  {
    _g->p_sequence_we=0;
  }
  _g->p_sequence_addr2=_g->ni170_r_e_g_1;
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,1-0) == 1) {
    _g->p_sequence_re2=_g->newState;
  } else  {
    _g->p_sequence_re2=0;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_addr=(((_g->r_k)>>(0-0))&0x1ff);
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_addr=(((_g->r_k)>>(0-0))&0x1ff);
  } else  {
    _g->p_sequence_addr=0x0;
  }
  _g->p_pwm_din=_g->ni409_nSamplePwm;
  if (_g->thisState == stateType_b2s2) {
    _g->p_pwm_we=1;
  } else  {
    _g->p_pwm_we=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1 && BIT(_g->s_b10_predicates,0-0) == 1) {
    _g->p_pwm_addr2=_g->ni428_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1) {
    _g->p_pwm_addr2=_g->r_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1) {
    _g->p_pwm_addr2=_g->s_b10_1.f_r_e_g_4;
  } else  {
    _g->p_pwm_addr2=0x0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,2-0) == 1 && BIT(_g->s_b10_1.predicates,0-0) == 1) {
    _g->p_pwm_re2=_g->newState;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,3-0) == 1 && BIT(_g->s_b10_2.predicates,4-0) == 1) {
    _g->p_pwm_re2=_g->newState;
  } else  {
    _g->p_pwm_re2=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,2-0) == 1 && BIT(_g->s_b10_1.predicates,2-0) == 1) {
    _g->p_pwm_re=_g->newState;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,3-0) == 1 && BIT(_g->s_b10_2.predicates,6-0) == 1) {
    _g->p_pwm_re=_g->newState;
  } else  {
    _g->p_pwm_re=0;
  }
  if (_g->thisState == stateType_b2s2) {
    _g->p_pwm_addr=_g->r_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1 && BIT(_g->s_b10_predicates,2-0) == 1) {
    _g->p_pwm_addr=_g->ni431_r_e_g_3;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1) {
    _g->p_pwm_addr=_g->r_r_e_g_3;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1) {
    _g->p_pwm_addr=_g->s_b10_1.f_r_e_g_5;
  } else  {
    _g->p_pwm_addr=0x0;
  }
  if (_g->thisState == stateType_b6s1) {
    _g->p_dna_stream_en=(_g->stateEn & (!_g->p_dna_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_dna_stream_en=(_g->stateEn & (!_g->p_dna_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_dna_stream_en=_g->stateEn;
  } else  {
    _g->p_dna_stream_en=0;
  }
  if (_g->thisState == stateType_b4s0) {
    _g->p_iteration_stream_en=(_g->stateEn & (!_g->p_iteration_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_iteration_stream_en=_g->stateEn;
  } else  {
    _g->p_iteration_stream_en=0;
  }
  if (_g->thisState == stateType_b2s1) {
    _g->p_pwm_stream_en=(_g->stateEn & (!_g->p_pwm_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_pwm_stream_en=_g->stateEn;
  } else  {
    _g->p_pwm_stream_en=0;
  }
  _g->ni444_k=((_g->r_k + 0x1));
  _g->ni443_nSampleDna=_g->r_dna_stream;
  _g->ni442_suif_tmp2=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_dna_stream_eos)) == 0x0));
  _g->ni441_nHitScore=_g->r_sum;
  _g->ni440_nHitStart=_g->r_counter;
  switch (_g->s_b10_state) {
  case pipeStateType_flush:
    _g->s_b10_break=1;
    break;
  default:
    _g->s_b10_break=0;
    break;
  }
  if (BIT(_g->s_b10_5.predicates,6-0) == 1) {
    _g->t_9=_g->ni436_sum;
  } else if (BIT(_g->s_b10_5.predicates,4-0) == 1) {
    _g->t_9=_g->ni433_sum;
  } else  {
    _g->t_9=_g->s_b10_5.f_sum;
  }
  if (BIT(_g->s_b10_4.predicates,2-0) == 1) {
    _g->t_8=_g->ni430_sum;
  } else if (BIT(_g->s_b10_4.predicates,0-0) == 1) {
    _g->t_8=_g->ni427_sum;
  } else  {
    _g->t_8=_g->s_b10_6.f_sum;
  }
  _g->ni437_r_e_g_5=((0x18 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni434_r_e_g_4=((0x10 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni439_suif_tmp4=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->ni438_l),SIGN32(0x8),int));
  _g->ni400_r_e_g_2=((_g->r_l + 0x1));
  _g->ni424_suif_tmp90=sign_ext_2(_g->r_counter,32);
  _g->ni418_k=((_g->r_k + 0x1));
  _g->ni414_dnaLength=_g->r_iteration_stream;
  _g->ni413_suif_tmp=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_iteration_stream_eos)) == 0x0));
  _g->ni412_j=((_g->r_j + 0x1));
  _g->ni410_r_e_g_0=((((((_g->r_i)>>(0-0))&0x1f) << 3) + (((_g->r_j)>>(0-0))&0x1f)));
  _g->ni411_i=((_g->r_i + 0x1));
  switch (_g->thisState) {
  case stateType_init:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b0s0:
    _g->nextState=stateType_b1s0;
    break;
  case stateType_b1s0:
    if ((!BIT(_g->ni406_suif_tmp9,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b1s1;
    }
    break;
  case stateType_b1s1:
    _g->nextState=stateType_b2s0;
    break;
  case stateType_b2s0:
    if ((!BIT(_g->ni408_suif_tmp10,0-0)) == 1) {
      _g->nextState=stateType_b3s0;
    } else  {
      _g->nextState=stateType_b2s1;
    }
    break;
  case stateType_b2s1:
    _g->nextState=stateType_b2s2;
    break;
  case stateType_b2s2:
    _g->nextState=stateType_b2s0;
    break;
  case stateType_b3s0:
    _g->nextState=stateType_b1s0;
    break;
  case stateType_b4s0:
    _g->nextState=stateType_b4s1;
    break;
  case stateType_b4s1:
    if (BIT(_g->r_suif_tmp,0-0) == 1) {
      _g->nextState=stateType_b5s0;
    } else if ((!BIT(_g->r_suif_tmp,0-0)) == 1) {
      _g->nextState=stateType_b5s0;
    } else  {
      _g->nextState=stateType_b4s1;
    }
    break;
  case stateType_b5s0:
    _g->nextState=stateType_b6s0;
    break;
  case stateType_b6s0:
    if ((!BIT(_g->ni416_suif_tmp11,0-0)) == 1) {
      _g->nextState=stateType_b7s0;
    } else  {
      _g->nextState=stateType_b6s1;
    }
    break;
  case stateType_b6s1:
    _g->nextState=stateType_b6s2;
    break;
  case stateType_b6s2:
    _g->nextState=stateType_b6s0;
    break;
  case stateType_b7s0:
    if (BIT(_g->ni421_suif_tmp0,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni421_suif_tmp0,0-0)) == 1) {
      _g->nextState=stateType_b15s0;
    } else  {
      _g->nextState=stateType_b7s0;
    }
    break;
  case stateType_b8s0:
    if (BIT(_g->ni423_suif_tmp3,0-0) == 1) {
      _g->nextState=stateType_b9s0;
    } else if ((!BIT(_g->ni423_suif_tmp3,0-0)) == 1) {
      _g->nextState=stateType_b11s0;
    } else  {
      _g->nextState=stateType_b8s0;
    }
    break;
  case stateType_b9s0:
    _g->nextState=stateType_b10s0;
    break;
  case stateType_b10s0:
    _g->nextState=stateType_b11s0;
    break;
  case stateType_b11s0:
    _g->nextState=stateType_b11s1;
    break;
  case stateType_b11s1:
    if (BIT(_g->r_suif_tmp2,0-0) == 1) {
      _g->nextState=stateType_b12s0;
    } else if ((!BIT(_g->r_suif_tmp2,0-0)) == 1) {
      _g->nextState=stateType_b13s0;
    } else  {
      _g->nextState=stateType_b11s1;
    }
    break;
  case stateType_b12s0:
    _g->nextState=stateType_b14s0;
    break;
  case stateType_b13s0:
    _g->nextState=stateType_b15s0;
    break;
  case stateType_b14s0:
    if (BIT(_g->ni447_suif_tmp1,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni447_suif_tmp1,0-0)) == 1) {
      _g->nextState=stateType_b15s0;
    } else  {
      _g->nextState=stateType_b14s0;
    }
    break;
  case stateType_b15s0:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b16s0:
    _g->nextState=stateType_finished;
    break;
  case stateType_finished:
    _g->nextState=stateType_finished;
    break;
  default:
    _g->nextState=stateType_init;
    break;
  }
  _g->fadd_ll_0_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni196_pwm);
  _g->fadd_ll_1_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni207_pwm);
  _g->fadd_ll_2_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni218_pwm);
  _g->fadd_ll_3_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni229_pwm);
  _g->p_sequence_dout=_g->ram_5_mem[(_g->ram_5_raddr)-0];
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,3-0) == 1 && BIT(_g->s_b10_2.predicates,6-0) == 1) {
    _g->ti227_req=1;
  } else  {
    _g->ti227_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,3-0) == 1 && BIT(_g->s_b10_2.predicates,4-0) == 1) {
    _g->ti216_req=1;
  } else  {
    _g->ti216_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1 && BIT(_g->s_b10_1.predicates,2-0) == 1) {
    _g->ti205_req=1;
  } else  {
    _g->ti205_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1 && BIT(_g->s_b10_1.predicates,0-0) == 1) {
    _g->ti194_req=1;
  } else  {
    _g->ti194_req=0;
  }
  if (_g->newState == 1) {
    _g->p_sequence_imm=_g->p_sequence_dout;
  } else  {
    _g->p_sequence_imm=_g->r_sequence;
  }
  if (_g->thisState == stateType_b15s0) {
    _g->p_sum_stream_eos=1;
  } else  {
    _g->p_sum_stream_eos=0;
  }
  _g->p_sum_stream_data=_g->ni441_nHitScore;
  if (_g->thisState == stateType_b11s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else  {
    _g->p_sum_stream_en=0;
  }
  if (_g->thisState == stateType_b15s0) {
    _g->p_counter_stream_eos=1;
  } else  {
    _g->p_counter_stream_eos=0;
  }
  _g->p_counter_stream_data=_g->ni440_nHitStart;
  if (_g->thisState == stateType_b11s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else  {
    _g->p_counter_stream_en=0;
  }
  _g->t_10=(((_g->r_k)>>(0-0))&0x1ff);
  _g->ni278_sequence=_g->r_nSampleDna;
  _g->t_0=(((_g->r_k)>>(0-0))&0x1ff);
  _g->ni134_sequence=_g->ni417_nSampleDna;
  _g->ni88_pwm=_g->ni409_nSamplePwm;
}

static void clk_proc(PWM_rtl_t *_g)

{

  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_sequence_we == 1) {
      _g->ram_5_mem[(_g->p_sequence_addr)-0]=_g->p_sequence_din;
    }
    _g->ram_5_raddr=_g->p_sequence_addr;
    _g->ram_5_raddr2=_g->p_sequence_addr2;
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_pwm_we == 1) {
      _g->ram_4_mem[(_g->p_pwm_addr)-0]=_g->p_pwm_din;
    }
    _g->ram_4_raddr=_g->p_pwm_addr;
    _g->ram_4_raddr2=_g->p_pwm_addr2;
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti227_pipeen == 1) {
      _g->fadd_ll_3_queue_mem[(_g->fadd_ll_3_queue_in_ptr)-0]=_g->fadd_ll_3_value;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti216_pipeen == 1) {
      _g->fadd_ll_2_queue_mem[(_g->fadd_ll_2_queue_in_ptr)-0]=_g->fadd_ll_2_value;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti205_pipeen == 1) {
      _g->fadd_ll_1_queue_mem[(_g->fadd_ll_1_queue_in_ptr)-0]=_g->fadd_ll_1_value;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti194_pipeen == 1) {
      _g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_in_ptr)-0]=_g->fadd_ll_0_value;
    }
  }
  if (_g->reset == 1) {
    _g->newState=1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b10s0:
      _g->newState=(!_g->s_b10_stall);
      break;
    default:
      _g->newState=_g->stateEn;
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->s_b10_state == pipeStateType_init) {
      _g->s_b10_6.f_sum=_g->r_sum;
    } else if (BIT(_g->s_b10_vwrite,6-0) == 1) {
      _g->s_b10_6.f_sum=_g->t_9;
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,0-0),0-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,1-0),1-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,2-0),2-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,3-0),3-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,4-0),4-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,5-0),5-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,6-0),6-0);
      _g->s_b10_6.predicates=_g->s_b10_6.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_5.predicates,7-0),7-0);
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_stage=0x0;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->s_b10_state == pipeStateType_idle) {
      _g->s_b10_stage=0x0;
    } else if (_g->thisState == stateType_b10s0 && _g->s_b10_stall == 0) {
      _g->s_b10_stage=(((((_g->s_b10_vcont)>>(0-0))&0x3f)<<1)|((!_g->s_b10_break) & BIT(_g->s_b10_delay,0-0)));
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b0s0:
      if (_g->stateEn == 1) {
        _g->r_motifLength=_g->ni404_motifLength;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b0s0:
      if (_g->stateEn == 1) {
        _g->r_j=_g->ni405_j;
      }
      break;
    case stateType_b3s0:
      if (_g->stateEn == 1) {
        _g->r_j=_g->ni412_j;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b1s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp9=_g->ni406_suif_tmp9;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b1s1:
      if (_g->stateEn == 1) {
        _g->r_i=_g->ni407_i;
      }
      break;
    case stateType_b2s1:
      if (_g->stateEn == 1) {
        _g->r_i=_g->ni411_i;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b2s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp10=_g->ni408_suif_tmp10;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b2s1:
      if (_g->stateEn == 1) {
        _g->r_r_e_g_0=_g->ni410_r_e_g_0;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b2s2:
      if (_g->stateEn == 1) {
        _g->r_nSamplePwm=_g->ni409_nSamplePwm;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp=_g->ni413_suif_tmp;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s1:
      if (_g->stateEn == 1) {
        _g->r_dnaLength=_g->ni414_dnaLength;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b5s0:
      if (_g->stateEn == 1) {
        _g->r_k=_g->ni415_k;
      }
      break;
    case stateType_b6s2:
      if (_g->stateEn == 1) {
        _g->r_k=_g->ni418_k;
      }
      break;
    case stateType_b12s0:
      if (_g->stateEn == 1) {
        _g->r_k=_g->ni444_k;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b6s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp11=_g->ni416_suif_tmp11;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b6s2:
      if (_g->stateEn == 1) {
        _g->r_nSampleDna=_g->ni417_nSampleDna;
      }
      break;
    case stateType_b11s1:
      if (_g->stateEn == 1) {
        _g->r_nSampleDna=_g->ni443_nSampleDna;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b7s0:
      if (_g->stateEn == 1) {
        _g->r_counter=_g->ni419_counter;
      }
      break;
    case stateType_b14s0:
      if (_g->stateEn == 1) {
        _g->r_counter=_g->ni445_counter;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b7s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp0=_g->ni421_suif_tmp0;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b8s0:
      if (_g->stateEn == 1) {
        _g->r_l=_g->ni422_l;
      }
      break;
    case stateType_b10s0:
      if (BIT(_g->s_b10_vwrite,1-0) == 1) {
        _g->r_l=_g->ni438_l;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b8s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp3=_g->ni423_suif_tmp3;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b9s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp90=_g->ni424_suif_tmp90;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b11s0:
      if (_g->stateEn == 1) {
        _g->r_nHitStart=_g->ni440_nHitStart;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b11s0:
      if (_g->stateEn == 1) {
        _g->r_nHitScore=_g->ni441_nHitScore;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b11s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp2=_g->ni442_suif_tmp2;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b14s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp1=_g->ni447_suif_tmp1;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_pwm_stream_en & _g->p_pwm_stream_rdy) == 1) {
      _g->r_pwm_stream=_g->p_pwm_stream_data;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_iteration_stream_en & _g->p_iteration_stream_rdy) == 1) {
      _g->r_iteration_stream=_g->p_iteration_stream_data;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_dna_stream_en & _g->p_dna_stream_rdy) == 1) {
      _g->r_dna_stream=_g->p_dna_stream_data;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_pwm_re == 1) {
      _g->r_pwm=_g->p_pwm_dout;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_pwm_re2 == 1) {
      _g->r2_pwm=_g->p_pwm_dout2;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_sequence_re == 1) {
      _g->r_sequence=_g->p_sequence_dout;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->p_sequence_re2 == 1) {
      _g->r2_sequence=_g->p_sequence_dout2;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b7s0:
      if (_g->stateEn == 1) {
        _g->r_sum=_g->ni420_sum;
      }
      break;
    case stateType_b10s0:
      if (BIT(_g->s_b10_vwrite,5-0) == 1) {
        _g->r_sum=_g->t_8;
      }
      if (BIT(_g->s_b10_vwrite,6-0) == 1) {
        _g->r_sum=_g->t_9;
      }
      break;
    case stateType_b14s0:
      if (_g->stateEn == 1) {
        _g->r_sum=_g->ni446_sum;
      }
      break;
    default:
      break;
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_delay=0x1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->s_b10_state == pipeStateType_idle) {
      _g->s_b10_delay=0x1;
    } else if (_g->thisState == stateType_b10s0 && _g->s_b10_stall == 0 && _g->s_b10_done == 0) {
      _g->s_b10_delay=((BIT(_g->s_b10_delay,0-0)<<5)|(((_g->s_b10_delay)>>(1-0))&0x1f));
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,5-0) == 1) {
      _g->s_b10_5.f_sum=_g->t_8;
      _g->s_b10_5.f_r_e_g_5=_g->s_b10_4.f_r_e_g_5;
      _g->s_b10_5.f_r_e_g_4=_g->s_b10_4.f_r_e_g_4;
      _g->s_b10_5.f_r_e_g_3=_g->s_b10_4.f_r_e_g_3;
      _g->s_b10_5.f_r_e_g_0=_g->s_b10_4.f_r_e_g_0;
      _g->s_b10_5.f_suif_tmp4=_g->s_b10_4.f_suif_tmp4;
      _g->s_b10_5.f_r_e_g_2=_g->s_b10_4.f_r_e_g_2;
      _g->s_b10_5.f_r_e_g_1=_g->s_b10_4.f_r_e_g_1;
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,0-0),0-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,1-0),1-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,2-0),2-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,3-0),3-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,4-0),4-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,5-0),5-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,6-0),6-0);
      _g->s_b10_5.predicates=_g->s_b10_5.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_4.predicates,7-0),7-0);
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti194_pipeen == 1) {
      _g->fadd_ll_0_queue_in_ptr=_g->fadd_ll_0_queue_next_ptr;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti205_pipeen == 1) {
      _g->fadd_ll_1_queue_in_ptr=_g->fadd_ll_1_queue_next_ptr;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti216_pipeen == 1) {
      _g->fadd_ll_2_queue_in_ptr=_g->fadd_ll_2_queue_next_ptr;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti227_pipeen == 1) {
      _g->fadd_ll_3_queue_in_ptr=_g->fadd_ll_3_queue_next_ptr;
    }
  }
  if (_g->reset == 1) {
    _g->thisState=stateType_init;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->stateEn == 1) {
      _g->thisState=_g->nextState;
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_state=pipeStateType_idle;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->s_b10_state) {
    case pipeStateType_idle:
      if (_g->stateEn == 1 && _g->nextState == stateType_b10s0) {
        _g->s_b10_state=pipeStateType_init;
      } else  {
        _g->s_b10_state=pipeStateType_idle;
      }
      break;
    case pipeStateType_init:
      _g->s_b10_state=pipeStateType_run;
      break;
    case pipeStateType_run:
      if ((!_g->s_b10_loop) == 1) {
        _g->s_b10_state=pipeStateType_idle;
      } else if (_g->s_b10_break == 1) {
        _g->s_b10_state=pipeStateType_flush;
      } else  {
        _g->s_b10_state=pipeStateType_run;
      }
      break;
    case pipeStateType_flush:
      if (_g->s_b10_flushed == 1) {
        _g->s_b10_state=pipeStateType_idle;
      } else  {
        _g->s_b10_state=pipeStateType_flush;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,4-0) == 1) {
      _g->s_b10_4.f_r_e_g_5=_g->s_b10_3.f_r_e_g_5;
      _g->s_b10_4.f_r_e_g_4=_g->s_b10_3.f_r_e_g_4;
      _g->s_b10_4.f_r_e_g_3=_g->s_b10_3.f_r_e_g_3;
      _g->s_b10_4.f_r_e_g_0=_g->s_b10_3.f_r_e_g_0;
      _g->s_b10_4.f_suif_tmp4=_g->s_b10_3.f_suif_tmp4;
      _g->s_b10_4.f_r_e_g_2=_g->s_b10_3.f_r_e_g_2;
      _g->s_b10_4.f_r_e_g_1=_g->s_b10_3.f_r_e_g_1;
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,0-0),0-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,1-0),1-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,2-0),2-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,3-0),3-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,4-0),4-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,5-0),5-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,6-0),6-0);
      _g->s_b10_4.predicates=_g->s_b10_4.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_3.predicates,7-0),7-0);
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,3-0) == 1) {
      _g->s_b10_3.f_r_e_g_5=_g->s_b10_2.f_r_e_g_5;
      _g->s_b10_3.f_r_e_g_4=_g->s_b10_2.f_r_e_g_4;
      _g->s_b10_3.f_r_e_g_3=_g->s_b10_2.f_r_e_g_3;
      _g->s_b10_3.f_r_e_g_0=_g->s_b10_2.f_r_e_g_0;
      _g->s_b10_3.f_suif_tmp4=_g->s_b10_2.f_suif_tmp4;
      _g->s_b10_3.f_r_e_g_2=_g->s_b10_2.f_r_e_g_2;
      _g->s_b10_3.f_r_e_g_1=_g->s_b10_2.f_r_e_g_1;
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,0-0),0-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,1-0),1-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,2-0),2-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,3-0),3-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,4-0),4-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,5-0),5-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,6-0),6-0);
      _g->s_b10_3.predicates=_g->s_b10_3.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_2.predicates,7-0),7-0);
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,2-0) == 1) {
      _g->s_b10_2.f_r_e_g_5=_g->s_b10_1.f_r_e_g_5;
      _g->s_b10_2.f_r_e_g_4=_g->s_b10_1.f_r_e_g_4;
      _g->s_b10_2.f_r_e_g_3=_g->s_b10_1.f_r_e_g_3;
      _g->s_b10_2.f_r_e_g_0=_g->s_b10_1.f_r_e_g_0;
      _g->s_b10_2.f_suif_tmp4=_g->s_b10_1.f_suif_tmp4;
      _g->s_b10_2.f_r_e_g_2=_g->s_b10_1.f_r_e_g_2;
      _g->s_b10_2.f_r_e_g_1=_g->s_b10_1.f_r_e_g_1;
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,0-0),0-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,1-0),1-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,2-0),2-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,3-0),3-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,4-0),4-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,5-0),5-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,6-0),6-0);
      _g->s_b10_2.predicates=_g->s_b10_2.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_1.predicates,7-0),7-0);
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,1-0) == 1) {
      _g->s_b10_1.f_r_e_g_5=_g->ni437_r_e_g_5;
      _g->s_b10_1.f_r_e_g_4=_g->ni434_r_e_g_4;
      _g->s_b10_1.f_r_e_g_3=_g->ni431_r_e_g_3;
      _g->s_b10_1.f_r_e_g_0=_g->ni428_r_e_g_0;
      _g->s_b10_1.f_suif_tmp4=_g->ni439_suif_tmp4;
      _g->s_b10_1.f_r_e_g_2=_g->s_b10_0.f_r_e_g_2;
      _g->s_b10_1.f_r_e_g_1=_g->s_b10_0.f_r_e_g_1;
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,0-0),0-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),1-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,2-0),2-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),3-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,4-0),4-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),5-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,6-0),6-0);
      _g->s_b10_1.predicates=_g->s_b10_1.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,7-0),7-0);
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (BIT(_g->s_b10_vwrite,0-0) == 1) {
      _g->s_b10_0.f_r_e_g_2=_g->ni400_r_e_g_2;
      _g->s_b10_0.f_r_e_g_1=_g->ni170_r_e_g_1;
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
      _g->s_b10_0.predicates=_g->s_b10_0.predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) 0,7-0);
    }
  }
}

static void init_proc(PWM_rtl_t *_g)

{

  _g->ni404_motifLength=0x8;
  _g->ni405_j=0x0;
  _g->ni407_i=0x0;
  _g->ni415_k=0x0;
  _g->ni419_counter=0x0;
  _g->ni420_sum=0x0;
  _g->ni422_l=0x0;
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
  _g->s_b10_vstall=_g->s_b10_vstall&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
  _g->s_b10_vbreak=_g->s_b10_vbreak&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
  _g->ni446_sum=0x0;
  _g->p_sequence_re=0;
  if ((_g->s_b10_vstall & _g->s_b10_stage) == 0x0) {
    _g->s_b10_stall=0;
  } else  {
    _g->s_b10_stall=1;
  }
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,0-0),0-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,1-0),1-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,2-0),2-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,3-0),3-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,4-0),4-0);
  _g->s_b10_vcont=_g->s_b10_vcont&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,5-0),5-0);
  _g->ni445_counter=((_g->r_counter + 0x1)&0xffff);
  if (_g->s_b10_stall == 0 && _g->s_b10_vcont == 0x0) {
    _g->s_b10_flushed=1;
  } else  {
    _g->s_b10_flushed=0;
  }
  if (((BIT(_g->s_b10_stage,6-0) & (!BIT(_g->s_b10_vstall,6-0))) & (!BIT(_g->s_b10_5.f_suif_tmp4,0-0))) == 1) {
    _g->s_b10_loop=0;
  } else  {
    _g->s_b10_loop=1;
  }
  _g->ni406_suif_tmp9=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_j),SIGN32(0x8),int));
  _g->ni408_suif_tmp10=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_i),SIGN32(0x4),int));
  _g->ni416_suif_tmp11=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->r_k),SIGN32(0x8),int));
  _g->ni421_suif_tmp0=(((unsigned int)0x0<<1)|(unsigned int)LESS_EQ_SIGN(SIGN32(0x0),SIGN32(((sign_ext_2(_g->r_dnaLength,32) - 0x8))),int));
  _g->ni423_suif_tmp3=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->ni422_l),SIGN32(0x8),int));
  switch (_g->s_b10_state) {
  case pipeStateType_init:
    _g->s_b10_done=0;
    break;
  case pipeStateType_run:
    _g->s_b10_done=(!_g->s_b10_loop);
    break;
  case pipeStateType_flush:
    _g->s_b10_done=_g->s_b10_flushed;
    break;
  default:
    _g->s_b10_done=0;
    break;
  }
  _g->ni447_suif_tmp1=(((unsigned int)0x0<<1)|(unsigned int)LESS_EQ_SIGN(SIGN32(sign_ext_2(_g->ni445_counter,32)),SIGN32(((sign_ext_2(_g->r_dnaLength,32) - 0x8))),int));
  switch (_g->s_b10_state) {
  case pipeStateType_flush:
    _g->s_b10_break=1;
    break;
  default:
    _g->s_b10_break=0;
    break;
  }
  switch (_g->thisState) {
  case stateType_init:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b0s0:
    _g->nextState=stateType_b1s0;
    break;
  case stateType_b1s0:
    if ((!BIT(_g->ni406_suif_tmp9,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b1s1;
    }
    break;
  case stateType_b1s1:
    _g->nextState=stateType_b2s0;
    break;
  case stateType_b2s0:
    if ((!BIT(_g->ni408_suif_tmp10,0-0)) == 1) {
      _g->nextState=stateType_b3s0;
    } else  {
      _g->nextState=stateType_b2s1;
    }
    break;
  case stateType_b2s1:
    _g->nextState=stateType_b2s2;
    break;
  case stateType_b2s2:
    _g->nextState=stateType_b2s0;
    break;
  case stateType_b3s0:
    _g->nextState=stateType_b1s0;
    break;
  case stateType_b4s0:
    _g->nextState=stateType_b4s1;
    break;
  case stateType_b4s1:
    if (BIT(_g->r_suif_tmp,0-0) == 1) {
      _g->nextState=stateType_b5s0;
    } else if ((!BIT(_g->r_suif_tmp,0-0)) == 1) {
      _g->nextState=stateType_b5s0;
    } else  {
      _g->nextState=stateType_b4s1;
    }
    break;
  case stateType_b5s0:
    _g->nextState=stateType_b6s0;
    break;
  case stateType_b6s0:
    if ((!BIT(_g->ni416_suif_tmp11,0-0)) == 1) {
      _g->nextState=stateType_b7s0;
    } else  {
      _g->nextState=stateType_b6s1;
    }
    break;
  case stateType_b6s1:
    _g->nextState=stateType_b6s2;
    break;
  case stateType_b6s2:
    _g->nextState=stateType_b6s0;
    break;
  case stateType_b7s0:
    if (BIT(_g->ni421_suif_tmp0,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni421_suif_tmp0,0-0)) == 1) {
      _g->nextState=stateType_b15s0;
    } else  {
      _g->nextState=stateType_b7s0;
    }
    break;
  case stateType_b8s0:
    if (BIT(_g->ni423_suif_tmp3,0-0) == 1) {
      _g->nextState=stateType_b9s0;
    } else if ((!BIT(_g->ni423_suif_tmp3,0-0)) == 1) {
      _g->nextState=stateType_b11s0;
    } else  {
      _g->nextState=stateType_b8s0;
    }
    break;
  case stateType_b9s0:
    _g->nextState=stateType_b10s0;
    break;
  case stateType_b10s0:
    _g->nextState=stateType_b11s0;
    break;
  case stateType_b11s0:
    _g->nextState=stateType_b11s1;
    break;
  case stateType_b11s1:
    if (BIT(_g->r_suif_tmp2,0-0) == 1) {
      _g->nextState=stateType_b12s0;
    } else if ((!BIT(_g->r_suif_tmp2,0-0)) == 1) {
      _g->nextState=stateType_b13s0;
    } else  {
      _g->nextState=stateType_b11s1;
    }
    break;
  case stateType_b12s0:
    _g->nextState=stateType_b14s0;
    break;
  case stateType_b13s0:
    _g->nextState=stateType_b15s0;
    break;
  case stateType_b14s0:
    if (BIT(_g->ni447_suif_tmp1,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni447_suif_tmp1,0-0)) == 1) {
      _g->nextState=stateType_b15s0;
    } else  {
      _g->nextState=stateType_b14s0;
    }
    break;
  case stateType_b15s0:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b16s0:
    _g->nextState=stateType_finished;
    break;
  case stateType_finished:
    _g->nextState=stateType_finished;
    break;
  default:
    _g->nextState=stateType_init;
    break;
  }
  if (_g->thisState == stateType_b2s1 && _g->p_pwm_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s0 && _g->p_iteration_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b6s1 && _g->p_dna_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b10s0 && _g->s_b10_done == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b11s0 && ((_g->p_counter_stream_rdy & _g->p_sum_stream_rdy) & _g->p_dna_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b15s0 && ((((_g->p_pwm_stream_eos & _g->p_iteration_stream_eos) & _g->p_dna_stream_eos) & _g->p_counter_stream_rdy) & _g->p_sum_stream_rdy) == 0) {
    _g->stateEn=0;
  } else  {
    _g->stateEn=1;
  }
  if (BIT(_g->s_b10_predicates,5-0) == 1) {
    _g->t_1=_g->ni435_suif_tmp8;
  } else  {
    _g->t_1=_g->r_suif_tmp8;
  }
  _g->_tmp1_32=1;
  while (_g->_tmp1_32) {
    _g->_tmp1_31=_g->t_1;
    if (BIT(_g->s_b10_predicates,3-0) == 1) {
      _g->t_2=_g->ni432_suif_tmp7;
    } else  {
      _g->t_2=_g->r_suif_tmp7;
    }
    _g->_tmp1_30=1;
    while (_g->_tmp1_30) {
      _g->_tmp1_29=_g->t_2;
      if (BIT(_g->s_b10_predicates,1-0) == 1) {
        _g->t_3=_g->ni429_suif_tmp6;
      } else  {
        _g->t_3=_g->r_suif_tmp6;
      }
      _g->_tmp1_28=1;
      while (_g->_tmp1_28) {
        _g->_tmp1_27=_g->t_3;
        if (BIT(_g->t_1,0-0) == 1) {
          _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),6-0);
        } else  {
          _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
        }
        _g->_tmp1_26=1;
        while (_g->_tmp1_26) {
          _g->_tmp1_25=_g->s_b10_predicates;
          if ((!BIT(_g->t_3,0-0)) == 1) {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),3-0);
          } else  {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
          }
          _g->_tmp1_24=1;
          while (_g->_tmp1_24) {
            _g->_tmp1_23=_g->s_b10_predicates;
            if ((!BIT(_g->t_1,0-0)) == 1) {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),7-0);
            } else  {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) 0,7-0);
            }
            _g->_tmp1_22=1;
            while (_g->_tmp1_22) {
              _g->_tmp1_21=_g->s_b10_predicates;
              if (BIT(_g->t_3,0-0) == 1) {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),2-0);
              } else  {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
              }
              _g->_tmp1_20=1;
              while (_g->_tmp1_20) {
                _g->_tmp1_19=_g->s_b10_predicates;
                if (BIT(_g->t_2,0-0) == 1) {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),4-0);
                } else  {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
                }
                _g->_tmp1_18=1;
                while (_g->_tmp1_18) {
                  _g->_tmp1_17=_g->s_b10_predicates;
                  _g->p_sequence_dout2=_g->ram_5_mem[(_g->ram_5_raddr2)-0];
                  if (_g->newState == 1) {
                    _g->p_sequence_imm2=_g->p_sequence_dout2;
                  } else  {
                    _g->p_sequence_imm2=_g->r2_sequence;
                  }
                  _g->ni168_sequence=_g->p_sequence_imm2;
                  _g->ni425_suif_tmp_0=sign_ext(_g->ni168_sequence,32);
                  _g->ni426_suif_tmp5=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x41));
                  if (BIT(_g->ni426_suif_tmp5,0-0) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) 1,0-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
                  }
                  if ((!BIT(_g->ni426_suif_tmp5,0-0)) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) 1,1-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
                  }
                  if ((!BIT(_g->t_2,0-0)) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),5-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
                  }
                  if (BIT(_g->t_2,0-0) == 1) {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,3-0),4-0);
                  } else  {
                    _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
                  }
                  _g->_tmp1_18=(int ) (_g->_tmp1_17 != _g->s_b10_predicates);
                }
                if (BIT(_g->t_3,0-0) == 1) {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),2-0);
                } else  {
                  _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
                }
                _g->_tmp1_20=(int ) (_g->_tmp1_19 != _g->s_b10_predicates);
              }
              if ((!BIT(_g->t_1,0-0)) == 1) {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),7-0);
              } else  {
                _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,7-0)|MKBIT((unsigned int ) 0,7-0);
              }
              _g->_tmp1_22=(int ) (_g->_tmp1_21 != _g->s_b10_predicates);
            }
            if ((!BIT(_g->t_3,0-0)) == 1) {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,1-0),3-0);
            } else  {
              _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
            }
            _g->_tmp1_24=(int ) (_g->_tmp1_23 != _g->s_b10_predicates);
          }
          if (BIT(_g->t_1,0-0) == 1) {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_predicates,5-0),6-0);
          } else  {
            _g->s_b10_predicates=_g->s_b10_predicates&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
          }
          _g->_tmp1_26=(int ) (_g->_tmp1_25 != _g->s_b10_predicates);
        }
        _g->ni429_suif_tmp6=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x43));
        if (BIT(_g->s_b10_predicates,1-0) == 1) {
          _g->t_3=_g->ni429_suif_tmp6;
        } else  {
          _g->t_3=_g->r_suif_tmp6;
        }
        _g->_tmp1_28=_g->_tmp1_27 != _g->t_3;
      }
      _g->ni432_suif_tmp7=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x47));
      if (BIT(_g->s_b10_predicates,3-0) == 1) {
        _g->t_2=_g->ni432_suif_tmp7;
      } else  {
        _g->t_2=_g->r_suif_tmp7;
      }
      _g->_tmp1_30=_g->_tmp1_29 != _g->t_2;
    }
    _g->ni435_suif_tmp8=(((unsigned int)0x0<<1)|(unsigned int)((((_g->ni425_suif_tmp_0)>>(0-0))&0xff) == 0x54));
    if (BIT(_g->s_b10_predicates,5-0) == 1) {
      _g->t_1=_g->ni435_suif_tmp8;
    } else  {
      _g->t_1=_g->r_suif_tmp8;
    }
    _g->_tmp1_32=_g->_tmp1_31 != _g->t_1;
  }
  if ((_g->fadd_ll_0_queue_in_ptr) < 3) {
    _g->fadd_ll_0_queue_next_ptr=(((_g->fadd_ll_0_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_0_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_1_queue_in_ptr) < 3) {
    _g->fadd_ll_1_queue_next_ptr=(((_g->fadd_ll_1_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_1_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_2_queue_in_ptr) < 3) {
    _g->fadd_ll_2_queue_next_ptr=(((_g->fadd_ll_2_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_2_queue_next_ptr=0x0;
  }
  if ((_g->fadd_ll_3_queue_in_ptr) < 3) {
    _g->fadd_ll_3_queue_next_ptr=(((_g->fadd_ll_3_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_3_queue_next_ptr=0x0;
  }
  _g->p_pwm_dout=_g->ram_4_mem[(_g->ram_4_raddr)-0];
  _g->p_pwm_dout2=_g->ram_4_mem[(_g->ram_4_raddr2)-0];
  _g->fadd_ll_3_queue_out_ptr=_g->fadd_ll_3_queue_next_ptr;
  _g->fadd_ll_2_queue_out_ptr=_g->fadd_ll_2_queue_next_ptr;
  _g->fadd_ll_1_queue_out_ptr=_g->fadd_ll_1_queue_next_ptr;
  _g->fadd_ll_0_queue_out_ptr=_g->fadd_ll_0_queue_next_ptr;
  if (_g->newState == 1) {
    _g->p_pwm_imm2=_g->p_pwm_dout2;
  } else  {
    _g->p_pwm_imm2=_g->r2_pwm;
  }
  if (_g->newState == 1) {
    _g->p_pwm_imm=_g->p_pwm_dout;
  } else  {
    _g->p_pwm_imm=_g->r_pwm;
  }
  _g->t_4=_g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_out_ptr)-0];
  _g->t_5=_g->fadd_ll_1_queue_mem[(_g->fadd_ll_1_queue_out_ptr)-0];
  _g->t_6=_g->fadd_ll_2_queue_mem[(_g->fadd_ll_2_queue_out_ptr)-0];
  _g->t_7=_g->fadd_ll_3_queue_mem[(_g->fadd_ll_3_queue_out_ptr)-0];
  _g->p_sequence_dout=_g->ram_5_mem[(_g->ram_5_raddr)-0];
  _g->ni409_nSamplePwm=_g->r_pwm_stream;
  _g->ni417_nSampleDna=_g->r_dna_stream;
  _g->ni170_r_e_g_1=(((((_g->r_l)>>(0-0))&0x1ff) + (((_g->r_suif_tmp90)>>(0-0))&0x1ff))&0x1ff);
  _g->ni438_l=_g->s_b10_0.f_r_e_g_2;
  _g->ni428_r_e_g_0=(((_g->r_l)>>(0-0))&0x1f);
  _g->ni431_r_e_g_3=((0x8 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni196_pwm=_g->p_pwm_imm2;
  _g->ni207_pwm=_g->p_pwm_imm;
  _g->ni218_pwm=_g->p_pwm_imm2;
  _g->ni229_pwm=_g->p_pwm_imm;
  _g->ni427_sum=_g->t_4;
  _g->ni430_sum=_g->t_5;
  _g->ni433_sum=_g->t_6;
  _g->ni436_sum=_g->t_7;
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,0-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,0-0),0-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,0-0)|MKBIT((unsigned int ) 0,0-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,1-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,1-0),1-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,1-0)|MKBIT((unsigned int ) 0,1-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,2-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,2-0),2-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,2-0)|MKBIT((unsigned int ) 0,2-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,3-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,3-0),3-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,3-0)|MKBIT((unsigned int ) 0,3-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,4-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,4-0),4-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,4-0)|MKBIT((unsigned int ) 0,4-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,5-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,5-0),5-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,5-0)|MKBIT((unsigned int ) 0,5-0);
  }
  if (_g->s_b10_stall == 0) {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,6-0)|MKBIT((unsigned int ) BIT(_g->s_b10_stage,6-0),6-0);
  } else  {
    _g->s_b10_vwrite=_g->s_b10_vwrite&~MKBIT(1,6-0)|MKBIT((unsigned int ) 0,6-0);
  }
  _g->ni440_nHitStart=_g->r_counter;
  _g->ni441_nHitScore=_g->r_sum;
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,6-0) == 1) {
    _g->ti227_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti227_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,3-0) == 1 && BIT(_g->s_b10_2.predicates,6-0) == 1) {
    _g->ti227_req=1;
  } else  {
    _g->ti227_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,4-0) == 1) {
    _g->ti216_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti216_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,3-0) == 1 && BIT(_g->s_b10_2.predicates,4-0) == 1) {
    _g->ti216_req=1;
  } else  {
    _g->ti216_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,2-0) == 1) {
    _g->ti205_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti205_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1 && BIT(_g->s_b10_1.predicates,2-0) == 1) {
    _g->ti205_req=1;
  } else  {
    _g->ti205_req=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_predicates,0-0) == 1) {
    _g->ti194_pipeen=(!_g->s_b10_stall);
  } else  {
    _g->ti194_pipeen=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1 && BIT(_g->s_b10_1.predicates,0-0) == 1) {
    _g->ti194_req=1;
  } else  {
    _g->ti194_req=0;
  }
  if (_g->newState == 1) {
    _g->p_sequence_imm=_g->p_sequence_dout;
  } else  {
    _g->p_sequence_imm=_g->r_sequence;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_din=_g->ni417_nSampleDna;
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_din=_g->r_nSampleDna;
  } else  {
    _g->p_sequence_din=0x0;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_we=1;
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_we=1;
  } else  {
    _g->p_sequence_we=0;
  }
  _g->p_sequence_addr2=_g->ni170_r_e_g_1;
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,1-0) == 1) {
    _g->p_sequence_re2=_g->newState;
  } else  {
    _g->p_sequence_re2=0;
  }
  if (_g->thisState == stateType_b6s2) {
    _g->p_sequence_addr=(((_g->r_k)>>(0-0))&0x1ff);
  } else if (_g->thisState == stateType_b12s0) {
    _g->p_sequence_addr=(((_g->r_k)>>(0-0))&0x1ff);
  } else  {
    _g->p_sequence_addr=0x0;
  }
  _g->p_pwm_din=_g->ni409_nSamplePwm;
  if (_g->thisState == stateType_b2s2) {
    _g->p_pwm_we=1;
  } else  {
    _g->p_pwm_we=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1 && BIT(_g->s_b10_predicates,0-0) == 1) {
    _g->p_pwm_addr2=_g->ni428_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1) {
    _g->p_pwm_addr2=_g->r_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1) {
    _g->p_pwm_addr2=_g->s_b10_1.f_r_e_g_4;
  } else  {
    _g->p_pwm_addr2=0x0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,2-0) == 1 && BIT(_g->s_b10_1.predicates,0-0) == 1) {
    _g->p_pwm_re2=_g->newState;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,3-0) == 1 && BIT(_g->s_b10_2.predicates,4-0) == 1) {
    _g->p_pwm_re2=_g->newState;
  } else  {
    _g->p_pwm_re2=0;
  }
  if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,2-0) == 1 && BIT(_g->s_b10_1.predicates,2-0) == 1) {
    _g->p_pwm_re=_g->newState;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_stage,3-0) == 1 && BIT(_g->s_b10_2.predicates,6-0) == 1) {
    _g->p_pwm_re=_g->newState;
  } else  {
    _g->p_pwm_re=0;
  }
  if (_g->thisState == stateType_b2s2) {
    _g->p_pwm_addr=_g->r_r_e_g_0;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1 && BIT(_g->s_b10_predicates,2-0) == 1) {
    _g->p_pwm_addr=_g->ni431_r_e_g_3;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,1-0) == 1) {
    _g->p_pwm_addr=_g->r_r_e_g_3;
  } else if (_g->thisState == stateType_b10s0 && BIT(_g->s_b10_vwrite,2-0) == 1) {
    _g->p_pwm_addr=_g->s_b10_1.f_r_e_g_5;
  } else  {
    _g->p_pwm_addr=0x0;
  }
  if (_g->thisState == stateType_b15s0) {
    _g->p_sum_stream_eos=1;
  } else  {
    _g->p_sum_stream_eos=0;
  }
  _g->p_sum_stream_data=_g->ni441_nHitScore;
  if (_g->thisState == stateType_b11s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else  {
    _g->p_sum_stream_en=0;
  }
  if (_g->thisState == stateType_b15s0) {
    _g->p_counter_stream_eos=1;
  } else  {
    _g->p_counter_stream_eos=0;
  }
  _g->p_counter_stream_data=_g->ni440_nHitStart;
  if (_g->thisState == stateType_b11s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else  {
    _g->p_counter_stream_en=0;
  }
  if (_g->thisState == stateType_b6s1) {
    _g->p_dna_stream_en=(_g->stateEn & (!_g->p_dna_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_dna_stream_en=(_g->stateEn & (!_g->p_dna_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_dna_stream_en=_g->stateEn;
  } else  {
    _g->p_dna_stream_en=0;
  }
  if (_g->thisState == stateType_b4s0) {
    _g->p_iteration_stream_en=(_g->stateEn & (!_g->p_iteration_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_iteration_stream_en=_g->stateEn;
  } else  {
    _g->p_iteration_stream_en=0;
  }
  if (_g->thisState == stateType_b2s1) {
    _g->p_pwm_stream_en=(_g->stateEn & (!_g->p_pwm_stream_eos));
  } else if (_g->thisState == stateType_b15s0) {
    _g->p_pwm_stream_en=_g->stateEn;
  } else  {
    _g->p_pwm_stream_en=0;
  }
  _g->ni444_k=((_g->r_k + 0x1));
  _g->t_10=(((_g->r_k)>>(0-0))&0x1ff);
  _g->ni278_sequence=_g->r_nSampleDna;
  _g->ni443_nSampleDna=_g->r_dna_stream;
  _g->ni442_suif_tmp2=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_dna_stream_eos)) == 0x0));
  if (BIT(_g->s_b10_5.predicates,6-0) == 1) {
    _g->t_9=_g->ni436_sum;
  } else if (BIT(_g->s_b10_5.predicates,4-0) == 1) {
    _g->t_9=_g->ni433_sum;
  } else  {
    _g->t_9=_g->s_b10_5.f_sum;
  }
  if (BIT(_g->s_b10_4.predicates,2-0) == 1) {
    _g->t_8=_g->ni430_sum;
  } else if (BIT(_g->s_b10_4.predicates,0-0) == 1) {
    _g->t_8=_g->ni427_sum;
  } else  {
    _g->t_8=_g->s_b10_6.f_sum;
  }
  _g->ni437_r_e_g_5=((0x18 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni434_r_e_g_4=((0x10 + (((_g->r_l)>>(0-0))&0x1f))&0x1f);
  _g->ni439_suif_tmp4=(((unsigned int)0x0<<1)|(unsigned int)LESS_SIGN(SIGN32(_g->ni438_l),SIGN32(0x8),int));
  _g->ni400_r_e_g_2=((_g->r_l + 0x1));
  _g->ni424_suif_tmp90=sign_ext_2(_g->r_counter,32);
  _g->ni418_k=((_g->r_k + 0x1));
  _g->t_0=(((_g->r_k)>>(0-0))&0x1ff);
  _g->ni134_sequence=_g->ni417_nSampleDna;
  _g->ni414_dnaLength=_g->r_iteration_stream;
  _g->ni413_suif_tmp=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_iteration_stream_eos)) == 0x0));
  _g->ni412_j=((_g->r_j + 0x1));
  _g->ni88_pwm=_g->ni409_nSamplePwm;
  _g->ni410_r_e_g_0=((((((_g->r_i)>>(0-0))&0x1f) << 3) + (((_g->r_j)>>(0-0))&0x1f)));
  _g->ni411_i=((_g->r_i + 0x1));
  _g->fadd_ll_0_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni196_pwm);
  _g->fadd_ll_1_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni207_pwm);
  _g->fadd_ll_2_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni218_pwm);
  _g->fadd_ll_3_value=(unsigned int ) fadd(_g->s_b10_6.f_sum,_g->ni229_pwm);
  if (_g->reset == 1) {
    _g->newState=1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b10s0:
      _g->newState=(!_g->s_b10_stall);
      break;
    default:
      _g->newState=_g->stateEn;
      break;
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_stage=0x0;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->s_b10_state == pipeStateType_idle) {
      _g->s_b10_stage=0x0;
    } else if (_g->thisState == stateType_b10s0 && _g->s_b10_stall == 0) {
      _g->s_b10_stage=(((((_g->s_b10_vcont)>>(0-0))&0x3f)<<1)|((!_g->s_b10_break) & BIT(_g->s_b10_delay,0-0)));
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_delay=0x1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->s_b10_state == pipeStateType_idle) {
      _g->s_b10_delay=0x1;
    } else if (_g->thisState == stateType_b10s0 && _g->s_b10_stall == 0 && _g->s_b10_done == 0) {
      _g->s_b10_delay=((BIT(_g->s_b10_delay,0-0)<<5)|(((_g->s_b10_delay)>>(1-0))&0x1f));
    }
  }
  if (_g->reset == 1) {
    _g->thisState=stateType_init;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->stateEn == 1) {
      _g->thisState=_g->nextState;
    }
  }
  if (_g->reset == 1) {
    _g->s_b10_state=pipeStateType_idle;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->s_b10_state) {
    case pipeStateType_idle:
      if (_g->stateEn == 1 && _g->nextState == stateType_b10s0) {
        _g->s_b10_state=pipeStateType_init;
      } else  {
        _g->s_b10_state=pipeStateType_idle;
      }
      break;
    case pipeStateType_init:
      _g->s_b10_state=pipeStateType_run;
      break;
    case pipeStateType_run:
      if ((!_g->s_b10_loop) == 1) {
        _g->s_b10_state=pipeStateType_idle;
      } else if (_g->s_b10_break == 1) {
        _g->s_b10_state=pipeStateType_flush;
      } else  {
        _g->s_b10_state=pipeStateType_run;
      }
      break;
    case pipeStateType_flush:
      if (_g->s_b10_flushed == 1) {
        _g->s_b10_state=pipeStateType_idle;
      } else  {
        _g->s_b10_state=pipeStateType_flush;
      }
      break;
    default:
      break;
    }
  }
}

PWM_rtl_if_t *create_PWM_rtl()

{
  PWM_rtl_if_t *ret;
  PWM_rtl_t *_g;
  ret=(PWM_rtl_if_t *)malloc(sizeof(PWM_rtl_if_t));
  ret->clk_deltap=clk_delta;
  ret->clk_procp=clk_proc;
  ret->init_procp=init_proc;
  ret->endp=_end_cycle;
  ret->data=_g=(PWM_rtl_t *)malloc(sizeof(PWM_rtl_t));
  memset(ret->data,0,sizeof(PWM_rtl_t));
  _g->ram_5_mem[0]=2400;
  _g->ram_4_mem[0]=1024;
  _g->fadd_ll_3_queue_mem[0]=128;
  ;
  _g->fadd_ll_2_queue_mem[0]=128;
  ;
  _g->fadd_ll_1_queue_mem[0]=128;
  ;
  _g->fadd_ll_0_queue_mem[0]=128;
  ;
  return(ret);
}

void enum_PWM_rtl(void (*enump)(), void *arg)
{
  (*enump)(arg,"reset",offsetof(PWM_rtl_t,reset),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_reset",offsetof(PWM_rtl_t,_sd_reset),sizeof(struct _sd_reset_s),1);
  (*enump)(arg,"sclk",offsetof(PWM_rtl_t,sclk),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_sclk",offsetof(PWM_rtl_t,_sd_sclk),sizeof(struct _sd_sclk_s),1);
  (*enump)(arg,"clk",offsetof(PWM_rtl_t,clk),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_clk",offsetof(PWM_rtl_t,_sd_clk),sizeof(struct _sd_clk_s),1);
  (*enump)(arg,"p_pwm_stream_rdy",offsetof(PWM_rtl_t,p_pwm_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_pwm_stream_rdy",offsetof(PWM_rtl_t,_sd_p_pwm_stream_rdy),sizeof(struct _sd_p_pwm_stream_rdy_s),1);
  (*enump)(arg,"p_pwm_stream_en",offsetof(PWM_rtl_t,p_pwm_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_pwm_stream_en",offsetof(PWM_rtl_t,_sd_p_pwm_stream_en),sizeof(struct _sd_p_pwm_stream_en_s),1);
  (*enump)(arg,"p_pwm_stream_eos",offsetof(PWM_rtl_t,p_pwm_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_pwm_stream_eos",offsetof(PWM_rtl_t,_sd_p_pwm_stream_eos),sizeof(struct _sd_p_pwm_stream_eos_s),1);
  (*enump)(arg,"p_pwm_stream_data",offsetof(PWM_rtl_t,p_pwm_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_pwm_stream_data",offsetof(PWM_rtl_t,_sd_p_pwm_stream_data),sizeof(struct _sd_p_pwm_stream_data_s),1);
  (*enump)(arg,"p_iteration_stream_rdy",offsetof(PWM_rtl_t,p_iteration_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_iteration_stream_rdy",offsetof(PWM_rtl_t,_sd_p_iteration_stream_rdy),sizeof(struct _sd_p_iteration_stream_rdy_s),1);
  (*enump)(arg,"p_iteration_stream_en",offsetof(PWM_rtl_t,p_iteration_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_iteration_stream_en",offsetof(PWM_rtl_t,_sd_p_iteration_stream_en),sizeof(struct _sd_p_iteration_stream_en_s),1);
  (*enump)(arg,"p_iteration_stream_eos",offsetof(PWM_rtl_t,p_iteration_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_iteration_stream_eos",offsetof(PWM_rtl_t,_sd_p_iteration_stream_eos),sizeof(struct _sd_p_iteration_stream_eos_s),1);
  (*enump)(arg,"p_iteration_stream_data",offsetof(PWM_rtl_t,p_iteration_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_iteration_stream_data",offsetof(PWM_rtl_t,_sd_p_iteration_stream_data),sizeof(struct _sd_p_iteration_stream_data_s),1);
  (*enump)(arg,"p_dna_stream_rdy",offsetof(PWM_rtl_t,p_dna_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_dna_stream_rdy",offsetof(PWM_rtl_t,_sd_p_dna_stream_rdy),sizeof(struct _sd_p_dna_stream_rdy_s),1);
  (*enump)(arg,"p_dna_stream_en",offsetof(PWM_rtl_t,p_dna_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_dna_stream_en",offsetof(PWM_rtl_t,_sd_p_dna_stream_en),sizeof(struct _sd_p_dna_stream_en_s),1);
  (*enump)(arg,"p_dna_stream_eos",offsetof(PWM_rtl_t,p_dna_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_dna_stream_eos",offsetof(PWM_rtl_t,_sd_p_dna_stream_eos),sizeof(struct _sd_p_dna_stream_eos_s),1);
  (*enump)(arg,"p_dna_stream_data",offsetof(PWM_rtl_t,p_dna_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_dna_stream_data",offsetof(PWM_rtl_t,_sd_p_dna_stream_data),sizeof(struct _sd_p_dna_stream_data_s),1);
  (*enump)(arg,"p_counter_stream_rdy",offsetof(PWM_rtl_t,p_counter_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_rdy",offsetof(PWM_rtl_t,_sd_p_counter_stream_rdy),sizeof(struct _sd_p_counter_stream_rdy_s),1);
  (*enump)(arg,"p_counter_stream_en",offsetof(PWM_rtl_t,p_counter_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_en",offsetof(PWM_rtl_t,_sd_p_counter_stream_en),sizeof(struct _sd_p_counter_stream_en_s),1);
  (*enump)(arg,"p_counter_stream_eos",offsetof(PWM_rtl_t,p_counter_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_eos",offsetof(PWM_rtl_t,_sd_p_counter_stream_eos),sizeof(struct _sd_p_counter_stream_eos_s),1);
  (*enump)(arg,"p_counter_stream_data",offsetof(PWM_rtl_t,p_counter_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_counter_stream_data",offsetof(PWM_rtl_t,_sd_p_counter_stream_data),sizeof(struct _sd_p_counter_stream_data_s),1);
  (*enump)(arg,"p_sum_stream_rdy",offsetof(PWM_rtl_t,p_sum_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_rdy",offsetof(PWM_rtl_t,_sd_p_sum_stream_rdy),sizeof(struct _sd_p_sum_stream_rdy_s),1);
  (*enump)(arg,"p_sum_stream_en",offsetof(PWM_rtl_t,p_sum_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_en",offsetof(PWM_rtl_t,_sd_p_sum_stream_en),sizeof(struct _sd_p_sum_stream_en_s),1);
  (*enump)(arg,"p_sum_stream_eos",offsetof(PWM_rtl_t,p_sum_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_eos",offsetof(PWM_rtl_t,_sd_p_sum_stream_eos),sizeof(struct _sd_p_sum_stream_eos_s),1);
  (*enump)(arg,"p_sum_stream_data",offsetof(PWM_rtl_t,p_sum_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_sum_stream_data",offsetof(PWM_rtl_t,_sd_p_sum_stream_data),sizeof(struct _sd_p_sum_stream_data_s),1);
  (*enump)(arg,"ram_5_mem",offsetof(PWM_rtl_t,ram_5_mem),sizeof(unsigned int [300]),0);
  (*enump)(arg,"ram_5_raddr",offsetof(PWM_rtl_t,ram_5_raddr),sizeof(unsigned int ),0);
  (*enump)(arg,"ram_5_raddr2",offsetof(PWM_rtl_t,ram_5_raddr2),sizeof(unsigned int ),0);
  (*enump)(arg,"ram_4_mem",offsetof(PWM_rtl_t,ram_4_mem),sizeof(unsigned int [32]),0);
  (*enump)(arg,"ram_4_raddr",offsetof(PWM_rtl_t,ram_4_raddr),sizeof(unsigned int ),0);
  (*enump)(arg,"ram_4_raddr2",offsetof(PWM_rtl_t,ram_4_raddr2),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_3_queue_mem",offsetof(PWM_rtl_t,fadd_ll_3_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"fadd_ll_3_queue_in_ptr",offsetof(PWM_rtl_t,fadd_ll_3_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_3_queue_out_ptr",offsetof(PWM_rtl_t,fadd_ll_3_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_3_queue_next_ptr",offsetof(PWM_rtl_t,fadd_ll_3_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_3_value",offsetof(PWM_rtl_t,fadd_ll_3_value),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_2_queue_mem",offsetof(PWM_rtl_t,fadd_ll_2_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"fadd_ll_2_queue_in_ptr",offsetof(PWM_rtl_t,fadd_ll_2_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_2_queue_out_ptr",offsetof(PWM_rtl_t,fadd_ll_2_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_2_queue_next_ptr",offsetof(PWM_rtl_t,fadd_ll_2_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_2_value",offsetof(PWM_rtl_t,fadd_ll_2_value),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_1_queue_mem",offsetof(PWM_rtl_t,fadd_ll_1_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"fadd_ll_1_queue_in_ptr",offsetof(PWM_rtl_t,fadd_ll_1_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_1_queue_out_ptr",offsetof(PWM_rtl_t,fadd_ll_1_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_1_queue_next_ptr",offsetof(PWM_rtl_t,fadd_ll_1_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_1_value",offsetof(PWM_rtl_t,fadd_ll_1_value),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_mem",offsetof(PWM_rtl_t,fadd_ll_0_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"fadd_ll_0_queue_in_ptr",offsetof(PWM_rtl_t,fadd_ll_0_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_out_ptr",offsetof(PWM_rtl_t,fadd_ll_0_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_next_ptr",offsetof(PWM_rtl_t,fadd_ll_0_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_value",offsetof(PWM_rtl_t,fadd_ll_0_value),sizeof(unsigned int ),0);
  (*enump)(arg,"thisState",offsetof(PWM_rtl_t,thisState),sizeof(enum stateType ),0);
  (*enump)(arg,"nextState",offsetof(PWM_rtl_t,nextState),sizeof(enum stateType ),0);
  (*enump)(arg,"stateEn",offsetof(PWM_rtl_t,stateEn),sizeof(unsigned char ),0);
  (*enump)(arg,"newState",offsetof(PWM_rtl_t,newState),sizeof(unsigned char ),0);
  (*enump)(arg,"r_pwm_stream",offsetof(PWM_rtl_t,r_pwm_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_iteration_stream",offsetof(PWM_rtl_t,r_iteration_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_dna_stream",offsetof(PWM_rtl_t,r_dna_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_i",offsetof(PWM_rtl_t,r_i),sizeof(unsigned int ),0);
  (*enump)(arg,"ni407_i",offsetof(PWM_rtl_t,ni407_i),sizeof(unsigned int ),0);
  (*enump)(arg,"ni411_i",offsetof(PWM_rtl_t,ni411_i),sizeof(unsigned int ),0);
  (*enump)(arg,"r_j",offsetof(PWM_rtl_t,r_j),sizeof(unsigned int ),0);
  (*enump)(arg,"ni405_j",offsetof(PWM_rtl_t,ni405_j),sizeof(unsigned int ),0);
  (*enump)(arg,"ni412_j",offsetof(PWM_rtl_t,ni412_j),sizeof(unsigned int ),0);
  (*enump)(arg,"r_k",offsetof(PWM_rtl_t,r_k),sizeof(unsigned int ),0);
  (*enump)(arg,"ni415_k",offsetof(PWM_rtl_t,ni415_k),sizeof(unsigned int ),0);
  (*enump)(arg,"ni418_k",offsetof(PWM_rtl_t,ni418_k),sizeof(unsigned int ),0);
  (*enump)(arg,"ni444_k",offsetof(PWM_rtl_t,ni444_k),sizeof(unsigned int ),0);
  (*enump)(arg,"r_l",offsetof(PWM_rtl_t,r_l),sizeof(unsigned int ),0);
  (*enump)(arg,"ni422_l",offsetof(PWM_rtl_t,ni422_l),sizeof(unsigned int ),0);
  (*enump)(arg,"ni438_l",offsetof(PWM_rtl_t,ni438_l),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nSamplePwm",offsetof(PWM_rtl_t,r_nSamplePwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni409_nSamplePwm",offsetof(PWM_rtl_t,ni409_nSamplePwm),sizeof(unsigned int ),0);
  (*enump)(arg,"r_pwm",offsetof(PWM_rtl_t,r_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni88_pwm",offsetof(PWM_rtl_t,ni88_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni196_pwm",offsetof(PWM_rtl_t,ni196_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni207_pwm",offsetof(PWM_rtl_t,ni207_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni218_pwm",offsetof(PWM_rtl_t,ni218_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"ni229_pwm",offsetof(PWM_rtl_t,ni229_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_we",offsetof(PWM_rtl_t,p_pwm_we),sizeof(unsigned char ),0);
  (*enump)(arg,"p_pwm_din",offsetof(PWM_rtl_t,p_pwm_din),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_dout",offsetof(PWM_rtl_t,p_pwm_dout),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_addr",offsetof(PWM_rtl_t,p_pwm_addr),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_addr2",offsetof(PWM_rtl_t,p_pwm_addr2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_dout2",offsetof(PWM_rtl_t,p_pwm_dout2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_imm",offsetof(PWM_rtl_t,p_pwm_imm),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_re",offsetof(PWM_rtl_t,p_pwm_re),sizeof(unsigned char ),0);
  (*enump)(arg,"r2_pwm",offsetof(PWM_rtl_t,r2_pwm),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_imm2",offsetof(PWM_rtl_t,p_pwm_imm2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_pwm_re2",offsetof(PWM_rtl_t,p_pwm_re2),sizeof(unsigned char ),0);
  (*enump)(arg,"r_dnaLength",offsetof(PWM_rtl_t,r_dnaLength),sizeof(unsigned int ),0);
  (*enump)(arg,"ni414_dnaLength",offsetof(PWM_rtl_t,ni414_dnaLength),sizeof(unsigned int ),0);
  (*enump)(arg,"r_motifLength",offsetof(PWM_rtl_t,r_motifLength),sizeof(unsigned int ),0);
  (*enump)(arg,"ni404_motifLength",offsetof(PWM_rtl_t,ni404_motifLength),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nSampleDna",offsetof(PWM_rtl_t,r_nSampleDna),sizeof(unsigned int ),0);
  (*enump)(arg,"ni417_nSampleDna",offsetof(PWM_rtl_t,ni417_nSampleDna),sizeof(unsigned int ),0);
  (*enump)(arg,"ni443_nSampleDna",offsetof(PWM_rtl_t,ni443_nSampleDna),sizeof(unsigned int ),0);
  (*enump)(arg,"r_sequence",offsetof(PWM_rtl_t,r_sequence),sizeof(unsigned int ),0);
  (*enump)(arg,"ni134_sequence",offsetof(PWM_rtl_t,ni134_sequence),sizeof(unsigned int ),0);
  (*enump)(arg,"ni168_sequence",offsetof(PWM_rtl_t,ni168_sequence),sizeof(unsigned int ),0);
  (*enump)(arg,"ni278_sequence",offsetof(PWM_rtl_t,ni278_sequence),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_we",offsetof(PWM_rtl_t,p_sequence_we),sizeof(unsigned char ),0);
  (*enump)(arg,"p_sequence_din",offsetof(PWM_rtl_t,p_sequence_din),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_dout",offsetof(PWM_rtl_t,p_sequence_dout),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_addr",offsetof(PWM_rtl_t,p_sequence_addr),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_addr2",offsetof(PWM_rtl_t,p_sequence_addr2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_dout2",offsetof(PWM_rtl_t,p_sequence_dout2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_imm",offsetof(PWM_rtl_t,p_sequence_imm),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_re",offsetof(PWM_rtl_t,p_sequence_re),sizeof(unsigned char ),0);
  (*enump)(arg,"r2_sequence",offsetof(PWM_rtl_t,r2_sequence),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_imm2",offsetof(PWM_rtl_t,p_sequence_imm2),sizeof(unsigned int ),0);
  (*enump)(arg,"p_sequence_re2",offsetof(PWM_rtl_t,p_sequence_re2),sizeof(unsigned char ),0);
  (*enump)(arg,"r_counter",offsetof(PWM_rtl_t,r_counter),sizeof(unsigned int ),0);
  (*enump)(arg,"ni419_counter",offsetof(PWM_rtl_t,ni419_counter),sizeof(unsigned int ),0);
  (*enump)(arg,"ni445_counter",offsetof(PWM_rtl_t,ni445_counter),sizeof(unsigned int ),0);
  (*enump)(arg,"r_sum",offsetof(PWM_rtl_t,r_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni420_sum",offsetof(PWM_rtl_t,ni420_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni427_sum",offsetof(PWM_rtl_t,ni427_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni430_sum",offsetof(PWM_rtl_t,ni430_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni433_sum",offsetof(PWM_rtl_t,ni433_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni436_sum",offsetof(PWM_rtl_t,ni436_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"ni446_sum",offsetof(PWM_rtl_t,ni446_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nHitStart",offsetof(PWM_rtl_t,r_nHitStart),sizeof(unsigned int ),0);
  (*enump)(arg,"ni440_nHitStart",offsetof(PWM_rtl_t,ni440_nHitStart),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nHitScore",offsetof(PWM_rtl_t,r_nHitScore),sizeof(unsigned int ),0);
  (*enump)(arg,"ni441_nHitScore",offsetof(PWM_rtl_t,ni441_nHitScore),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp",offsetof(PWM_rtl_t,r_suif_tmp),sizeof(unsigned int ),0);
  (*enump)(arg,"ni413_suif_tmp",offsetof(PWM_rtl_t,ni413_suif_tmp),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp0",offsetof(PWM_rtl_t,r_suif_tmp0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni421_suif_tmp0",offsetof(PWM_rtl_t,ni421_suif_tmp0),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp1",offsetof(PWM_rtl_t,r_suif_tmp1),sizeof(unsigned int ),0);
  (*enump)(arg,"ni447_suif_tmp1",offsetof(PWM_rtl_t,ni447_suif_tmp1),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp2",offsetof(PWM_rtl_t,r_suif_tmp2),sizeof(unsigned int ),0);
  (*enump)(arg,"ni442_suif_tmp2",offsetof(PWM_rtl_t,ni442_suif_tmp2),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp3",offsetof(PWM_rtl_t,r_suif_tmp3),sizeof(unsigned int ),0);
  (*enump)(arg,"ni423_suif_tmp3",offsetof(PWM_rtl_t,ni423_suif_tmp3),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp4",offsetof(PWM_rtl_t,r_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"ni439_suif_tmp4",offsetof(PWM_rtl_t,ni439_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp5",offsetof(PWM_rtl_t,r_suif_tmp5),sizeof(unsigned int ),0);
  (*enump)(arg,"ni426_suif_tmp5",offsetof(PWM_rtl_t,ni426_suif_tmp5),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp6",offsetof(PWM_rtl_t,r_suif_tmp6),sizeof(unsigned int ),0);
  (*enump)(arg,"ni429_suif_tmp6",offsetof(PWM_rtl_t,ni429_suif_tmp6),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp7",offsetof(PWM_rtl_t,r_suif_tmp7),sizeof(unsigned int ),0);
  (*enump)(arg,"ni432_suif_tmp7",offsetof(PWM_rtl_t,ni432_suif_tmp7),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp8",offsetof(PWM_rtl_t,r_suif_tmp8),sizeof(unsigned int ),0);
  (*enump)(arg,"ni435_suif_tmp8",offsetof(PWM_rtl_t,ni435_suif_tmp8),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp9",offsetof(PWM_rtl_t,r_suif_tmp9),sizeof(unsigned int ),0);
  (*enump)(arg,"ni406_suif_tmp9",offsetof(PWM_rtl_t,ni406_suif_tmp9),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp10",offsetof(PWM_rtl_t,r_suif_tmp10),sizeof(unsigned int ),0);
  (*enump)(arg,"ni408_suif_tmp10",offsetof(PWM_rtl_t,ni408_suif_tmp10),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp11",offsetof(PWM_rtl_t,r_suif_tmp11),sizeof(unsigned int ),0);
  (*enump)(arg,"ni416_suif_tmp11",offsetof(PWM_rtl_t,ni416_suif_tmp11),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp90",offsetof(PWM_rtl_t,r_suif_tmp90),sizeof(unsigned int ),0);
  (*enump)(arg,"ni424_suif_tmp90",offsetof(PWM_rtl_t,ni424_suif_tmp90),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp_0",offsetof(PWM_rtl_t,r_suif_tmp_0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni425_suif_tmp_0",offsetof(PWM_rtl_t,ni425_suif_tmp_0),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_0",offsetof(PWM_rtl_t,r_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni410_r_e_g_0",offsetof(PWM_rtl_t,ni410_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni428_r_e_g_0",offsetof(PWM_rtl_t,ni428_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_1",offsetof(PWM_rtl_t,r_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"ni170_r_e_g_1",offsetof(PWM_rtl_t,ni170_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_2",offsetof(PWM_rtl_t,r_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"ni400_r_e_g_2",offsetof(PWM_rtl_t,ni400_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_3",offsetof(PWM_rtl_t,r_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"ni431_r_e_g_3",offsetof(PWM_rtl_t,ni431_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_4",offsetof(PWM_rtl_t,r_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"ni434_r_e_g_4",offsetof(PWM_rtl_t,ni434_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_5",offsetof(PWM_rtl_t,r_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"ni437_r_e_g_5",offsetof(PWM_rtl_t,ni437_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"t_10",offsetof(PWM_rtl_t,t_10),sizeof(unsigned int ),0);
  (*enump)(arg,"t_9",offsetof(PWM_rtl_t,t_9),sizeof(unsigned int ),0);
  (*enump)(arg,"t_8",offsetof(PWM_rtl_t,t_8),sizeof(unsigned int ),0);
  (*enump)(arg,"ti227_pipeen",offsetof(PWM_rtl_t,ti227_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti227_req",offsetof(PWM_rtl_t,ti227_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_7",offsetof(PWM_rtl_t,t_7),sizeof(unsigned int ),0);
  (*enump)(arg,"ti216_pipeen",offsetof(PWM_rtl_t,ti216_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti216_req",offsetof(PWM_rtl_t,ti216_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_6",offsetof(PWM_rtl_t,t_6),sizeof(unsigned int ),0);
  (*enump)(arg,"ti205_pipeen",offsetof(PWM_rtl_t,ti205_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti205_req",offsetof(PWM_rtl_t,ti205_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_5",offsetof(PWM_rtl_t,t_5),sizeof(unsigned int ),0);
  (*enump)(arg,"ti194_pipeen",offsetof(PWM_rtl_t,ti194_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti194_req",offsetof(PWM_rtl_t,ti194_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_4",offsetof(PWM_rtl_t,t_4),sizeof(unsigned int ),0);
  (*enump)(arg,"t_3",offsetof(PWM_rtl_t,t_3),sizeof(unsigned int ),0);
  (*enump)(arg,"t_2",offsetof(PWM_rtl_t,t_2),sizeof(unsigned int ),0);
  (*enump)(arg,"t_1",offsetof(PWM_rtl_t,t_1),sizeof(unsigned int ),0);
  (*enump)(arg,"t_0",offsetof(PWM_rtl_t,t_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_state",offsetof(PWM_rtl_t,s_b10_state),sizeof(enum pipeStateType ),0);
  (*enump)(arg,"s_b10_0",offsetof(PWM_rtl_t,s_b10_0),sizeof(t_b10_0_t_t ),0);
  (*enump)(arg,"s_b10_0.predicates",offsetof(PWM_rtl_t,s_b10_0)+offsetof(t_b10_0_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_0.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_0)+offsetof(t_b10_0_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_0.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_0)+offsetof(t_b10_0_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1",offsetof(PWM_rtl_t,s_b10_1),sizeof(t_b10_1_t_t ),0);
  (*enump)(arg,"s_b10_1.predicates",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_suif_tmp4",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_0",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_3",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_4",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_1.f_r_e_g_5",offsetof(PWM_rtl_t,s_b10_1)+offsetof(t_b10_1_t_t,f_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2",offsetof(PWM_rtl_t,s_b10_2),sizeof(t_b10_2_t_t ),0);
  (*enump)(arg,"s_b10_2.predicates",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_suif_tmp4",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_0",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_3",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_4",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_2.f_r_e_g_5",offsetof(PWM_rtl_t,s_b10_2)+offsetof(t_b10_2_t_t,f_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3",offsetof(PWM_rtl_t,s_b10_3),sizeof(t_b10_3_t_t ),0);
  (*enump)(arg,"s_b10_3.predicates",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_suif_tmp4",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_0",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_3",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_4",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_3.f_r_e_g_5",offsetof(PWM_rtl_t,s_b10_3)+offsetof(t_b10_3_t_t,f_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4",offsetof(PWM_rtl_t,s_b10_4),sizeof(t_b10_4_t_t ),0);
  (*enump)(arg,"s_b10_4.predicates",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_suif_tmp4",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_0",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_3",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_4",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_4.f_r_e_g_5",offsetof(PWM_rtl_t,s_b10_4)+offsetof(t_b10_4_t_t,f_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5",offsetof(PWM_rtl_t,s_b10_5),sizeof(t_b10_5_t_t ),0);
  (*enump)(arg,"s_b10_5.predicates",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_1",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_1),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_2",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_2),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_suif_tmp4",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_0",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_3",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_3),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_4",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_4),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_r_e_g_5",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_r_e_g_5),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_5.f_sum",offsetof(PWM_rtl_t,s_b10_5)+offsetof(t_b10_5_t_t,f_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_6",offsetof(PWM_rtl_t,s_b10_6),sizeof(t_b10_6_t_t ),0);
  (*enump)(arg,"s_b10_6.predicates",offsetof(PWM_rtl_t,s_b10_6)+offsetof(t_b10_6_t_t,predicates),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_6.f_sum",offsetof(PWM_rtl_t,s_b10_6)+offsetof(t_b10_6_t_t,f_sum),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_stall",offsetof(PWM_rtl_t,s_b10_stall),sizeof(unsigned char ),0);
  (*enump)(arg,"s_b10_break",offsetof(PWM_rtl_t,s_b10_break),sizeof(unsigned char ),0);
  (*enump)(arg,"s_b10_loop",offsetof(PWM_rtl_t,s_b10_loop),sizeof(unsigned char ),0);
  (*enump)(arg,"s_b10_flushed",offsetof(PWM_rtl_t,s_b10_flushed),sizeof(unsigned char ),0);
  (*enump)(arg,"s_b10_done",offsetof(PWM_rtl_t,s_b10_done),sizeof(unsigned char ),0);
  (*enump)(arg,"s_b10_vstall",offsetof(PWM_rtl_t,s_b10_vstall),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_vbreak",offsetof(PWM_rtl_t,s_b10_vbreak),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_stage",offsetof(PWM_rtl_t,s_b10_stage),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_vwrite",offsetof(PWM_rtl_t,s_b10_vwrite),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_vcont",offsetof(PWM_rtl_t,s_b10_vcont),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_delay",offsetof(PWM_rtl_t,s_b10_delay),sizeof(unsigned int ),0);
  (*enump)(arg,"s_b10_predicates",offsetof(PWM_rtl_t,s_b10_predicates),sizeof(unsigned int ),0);
}

static unsigned int sign_ext(unsigned int v_2,int SIZE_2)
{
  unsigned int res=0x0;

  res=res&~(0xffffff<<(8-0))|((unsigned int ) ((((((((((((((((((((((((((((((((((((((((((((((BIT(v_2,7-0)<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<1)|BIT(v_2,7-0))<<(8-0));
  res=res&~(0xff<<(0-0))|((unsigned int ) v_2<<(0-0));
  return(res);
}

static unsigned int sign_ext_2(unsigned int v_2,int SIZE_2)
{
  unsigned int res=0x0;

  res=res&~(0xffff<<(16-0))|((unsigned int ) ((((((((((((((((((((((((((((((BIT(v_2,15-0)<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<1)|BIT(v_2,15-0))<<(16-0));
  res=res&~(0xffff<<(0-0))|((unsigned int ) v_2<<(0-0));
  return(res);
}

static unsigned int mkvec(unsigned char b_2)
{
  unsigned int res=0x0;

  res=res&~MKBIT(1,0-0)|MKBIT(b_2,0-0);
  return(res);
}

