///////////////////////////////////////////////////////////////////////////////
//
// Impulse-C(c) 2003-2008 Impulse Accelerated Technologies, Inc.
//

#define MAX_STREAMWIDTH 64	/* buffer width for FIFO in hardware */
#define MIN_STREAMDEPTH 1	/* minimum buffer size for FIFO in hardware */

#define DNA_INPUT_FILE "dna.txt"
#define PWM_INPUT_FILE "pwm.txt"
#define OUTPUT_FILE "out.txt"

#define COLUMNS 4 /* A,C,G,T */
#define ROWS 8 /* length of pattern/motif */

#define MAX_SEQUENCE 300

#define FILTER_QUEUE MAX_SEQUENCE /* FIFO length between PWM and Filter */
#define WRITE_QUEUE ((MAX_SEQUENCE*10)/100) /* FIFO length between Filter and Consumer */

#define	VALID_CHAR(a) (((a) > 64) && ((a) < 91) && ((a) != 74) && ((a) != 79) && ((a) != 85) ? (1)	: (0))
