#include <stddef.h>
#include "Filter.h"

static void _end_cycle(Filter_rtl_t *_g) {
  _g->_sd_reset.active=0;
  _g->_sd_reset.event=0;
  _g->_sd_reset.last_active++;
  _g->_sd_reset.last_event++;
  _g->_sd_sclk.active=0;
  _g->_sd_sclk.event=0;
  _g->_sd_sclk.last_active++;
  _g->_sd_sclk.last_event++;
  _g->_sd_clk.active=0;
  _g->_sd_clk.event=0;
  _g->_sd_clk.last_active++;
  _g->_sd_clk.last_event++;
  _g->_sd_p_threshold_stream_rdy.active=0;
  _g->_sd_p_threshold_stream_rdy.event=0;
  _g->_sd_p_threshold_stream_rdy.last_active++;
  _g->_sd_p_threshold_stream_rdy.last_event++;
  _g->_sd_p_threshold_stream_en.active=0;
  _g->_sd_p_threshold_stream_en.event=0;
  _g->_sd_p_threshold_stream_en.last_active++;
  _g->_sd_p_threshold_stream_en.last_event++;
  _g->_sd_p_threshold_stream_eos.active=0;
  _g->_sd_p_threshold_stream_eos.event=0;
  _g->_sd_p_threshold_stream_eos.last_active++;
  _g->_sd_p_threshold_stream_eos.last_event++;
  _g->_sd_p_threshold_stream_data.active=0;
  _g->_sd_p_threshold_stream_data.event=0;
  _g->_sd_p_threshold_stream_data.last_active++;
  _g->_sd_p_threshold_stream_data.last_event++;
  _g->_sd_p_counter_stream_rdy.active=0;
  _g->_sd_p_counter_stream_rdy.event=0;
  _g->_sd_p_counter_stream_rdy.last_active++;
  _g->_sd_p_counter_stream_rdy.last_event++;
  _g->_sd_p_counter_stream_en.active=0;
  _g->_sd_p_counter_stream_en.event=0;
  _g->_sd_p_counter_stream_en.last_active++;
  _g->_sd_p_counter_stream_en.last_event++;
  _g->_sd_p_counter_stream_eos.active=0;
  _g->_sd_p_counter_stream_eos.event=0;
  _g->_sd_p_counter_stream_eos.last_active++;
  _g->_sd_p_counter_stream_eos.last_event++;
  _g->_sd_p_counter_stream_data.active=0;
  _g->_sd_p_counter_stream_data.event=0;
  _g->_sd_p_counter_stream_data.last_active++;
  _g->_sd_p_counter_stream_data.last_event++;
  _g->_sd_p_sum_stream_rdy.active=0;
  _g->_sd_p_sum_stream_rdy.event=0;
  _g->_sd_p_sum_stream_rdy.last_active++;
  _g->_sd_p_sum_stream_rdy.last_event++;
  _g->_sd_p_sum_stream_en.active=0;
  _g->_sd_p_sum_stream_en.event=0;
  _g->_sd_p_sum_stream_en.last_active++;
  _g->_sd_p_sum_stream_en.last_event++;
  _g->_sd_p_sum_stream_eos.active=0;
  _g->_sd_p_sum_stream_eos.event=0;
  _g->_sd_p_sum_stream_eos.last_active++;
  _g->_sd_p_sum_stream_eos.last_event++;
  _g->_sd_p_sum_stream_data.active=0;
  _g->_sd_p_sum_stream_data.event=0;
  _g->_sd_p_sum_stream_data.last_active++;
  _g->_sd_p_sum_stream_data.last_event++;
  _g->_sd_p_start_stream_rdy.active=0;
  _g->_sd_p_start_stream_rdy.event=0;
  _g->_sd_p_start_stream_rdy.last_active++;
  _g->_sd_p_start_stream_rdy.last_event++;
  _g->_sd_p_start_stream_en.active=0;
  _g->_sd_p_start_stream_en.event=0;
  _g->_sd_p_start_stream_en.last_active++;
  _g->_sd_p_start_stream_en.last_event++;
  _g->_sd_p_start_stream_eos.active=0;
  _g->_sd_p_start_stream_eos.event=0;
  _g->_sd_p_start_stream_eos.last_active++;
  _g->_sd_p_start_stream_eos.last_event++;
  _g->_sd_p_start_stream_data.active=0;
  _g->_sd_p_start_stream_data.event=0;
  _g->_sd_p_start_stream_data.last_active++;
  _g->_sd_p_start_stream_data.last_event++;
  _g->_sd_p_score_stream_rdy.active=0;
  _g->_sd_p_score_stream_rdy.event=0;
  _g->_sd_p_score_stream_rdy.last_active++;
  _g->_sd_p_score_stream_rdy.last_event++;
  _g->_sd_p_score_stream_en.active=0;
  _g->_sd_p_score_stream_en.event=0;
  _g->_sd_p_score_stream_en.last_active++;
  _g->_sd_p_score_stream_en.last_event++;
  _g->_sd_p_score_stream_eos.active=0;
  _g->_sd_p_score_stream_eos.event=0;
  _g->_sd_p_score_stream_eos.last_active++;
  _g->_sd_p_score_stream_eos.last_event++;
  _g->_sd_p_score_stream_data.active=0;
  _g->_sd_p_score_stream_data.event=0;
  _g->_sd_p_score_stream_data.last_active++;
  _g->_sd_p_score_stream_data.last_event++;
}

static void clk_delta(Filter_rtl_t *_g)

{

  if ((_g->flteq_ll_1_queue_in_ptr) < 3) {
    _g->flteq_ll_1_queue_next_ptr=(((_g->flteq_ll_1_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->flteq_ll_1_queue_next_ptr=0x0;
  }
  _g->flteq_ll_1_queue_out_ptr=_g->flteq_ll_1_queue_next_ptr;
  if ((_g->fadd_ll_0_queue_in_ptr) < 3) {
    _g->fadd_ll_0_queue_next_ptr=(((_g->fadd_ll_0_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_0_queue_next_ptr=0x0;
  }
  _g->fadd_ll_0_queue_out_ptr=_g->fadd_ll_0_queue_next_ptr;
  _g->t_1=_g->flteq_ll_1_queue_mem[(_g->flteq_ll_1_queue_out_ptr)-0];
  _g->t_0=_g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_out_ptr)-0];
  if (_g->thisState == stateType_b0s0 && _g->p_threshold_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s0 && _g->p_counter_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s1 && _g->p_sum_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b8s0 && (_g->p_start_stream_rdy & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b10s0 && (_g->p_start_stream_rdy & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b11s0 && ((((_g->p_threshold_stream_eos & _g->p_counter_stream_eos) & _g->p_sum_stream_eos) & _g->p_start_stream_rdy) & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else  {
    _g->stateEn=1;
  }
  _g->ni229_suif_tmp=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|_g->r_r_e_g_0) != 0x0));
  _g->ni235_suif_tmp0=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_counter_stream_eos)) == 0x0));
  _g->ni239_suif_tmp2=(((unsigned int)0x0<<1)|(unsigned int)((((_g->r_filterMode)>>(0-0))&0x7) == 0x1));
  _g->ni241_suif_tmp3=(((unsigned int)0x0<<1)|(unsigned int)_g->t_1);
  _g->ni244_suif_tmp4=(((unsigned int)0x0<<1)|(unsigned int)((((_g->r_filterMode)>>(0-0))&0x7) == 0x1));
  if (_g->stateEn == 1) {
    _g->ti137_pipeen=1;
  } else  {
    _g->ti137_pipeen=0;
  }
  if (_g->stateEn == 1) {
    _g->ti132_pipeen=1;
  } else  {
    _g->ti132_pipeen=0;
  }
  if (_g->thisState == stateType_b4s1) {
    _g->p_sum_stream_en=(_g->stateEn & (!_g->p_sum_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else  {
    _g->p_sum_stream_en=0;
  }
  if (_g->thisState == stateType_b4s0) {
    _g->p_counter_stream_en=(_g->stateEn & (!_g->p_counter_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else  {
    _g->p_counter_stream_en=0;
  }
  if (_g->thisState == stateType_b0s0) {
    _g->p_threshold_stream_en=(_g->stateEn & (!_g->p_threshold_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_threshold_stream_en=_g->stateEn;
  } else  {
    _g->p_threshold_stream_en=0;
  }
  _g->ni243_nResultScore=_g->r_nHitScore;
  _g->ni242_nResultStart=_g->r_nHitStart;
  _g->ni240_nResultScore=_g->t_0;
  _g->ni238_nHitScore=_g->r_sum_stream;
  _g->ni237_suif_tmp1=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_sum_stream_eos)) == 0x0));
  _g->ni236_nHitStart=_g->r_counter_stream;
  _g->ni230_threshold=_g->r_threshold_stream;
  _g->ni75_r_e_g_0=mkvec(_g->p_threshold_stream_eos);
  switch (_g->thisState) {
  case stateType_init:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b0s0:
    _g->nextState=stateType_b0s1;
    break;
  case stateType_b0s1:
    if (BIT(_g->ni229_suif_tmp,0-0) == 1) {
      _g->nextState=stateType_b1s0;
    } else if ((!BIT(_g->ni229_suif_tmp,0-0)) == 1) {
      _g->nextState=stateType_b2s0;
    } else  {
      _g->nextState=stateType_b0s1;
    }
    break;
  case stateType_b1s0:
    _g->nextState=stateType_b3s0;
    break;
  case stateType_b2s0:
    _g->nextState=stateType_b3s0;
    break;
  case stateType_b3s0:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b4s0:
    if ((!BIT(_g->ni235_suif_tmp0,0-0)) == 1) {
      _g->nextState=stateType_b9s0;
    } else  {
      _g->nextState=stateType_b4s1;
    }
    break;
  case stateType_b4s1:
    _g->nextState=stateType_b4s2;
    break;
  case stateType_b4s2:
    if (BIT(_g->r_suif_tmp1,0-0) == 1) {
      _g->nextState=stateType_b5s0;
    } else if ((!BIT(_g->r_suif_tmp1,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b4s2;
    }
    break;
  case stateType_b5s0:
    if (BIT(_g->ni239_suif_tmp2,0-0) == 1) {
      _g->nextState=stateType_b6s0;
    } else if ((!BIT(_g->ni239_suif_tmp2,0-0)) == 1) {
      _g->nextState=stateType_b7s0;
    } else  {
      _g->nextState=stateType_b5s0;
    }
    break;
  case stateType_b6s0:
    _g->nextState=stateType_b6s1;
    break;
  case stateType_b6s1:
    _g->nextState=stateType_b6s2;
    break;
  case stateType_b6s2:
    _g->nextState=stateType_b6s3;
    break;
  case stateType_b6s3:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b7s0:
    _g->nextState=stateType_b7s1;
    break;
  case stateType_b7s1:
    _g->nextState=stateType_b7s2;
    break;
  case stateType_b7s2:
    _g->nextState=stateType_b7s3;
    break;
  case stateType_b7s3:
    if (BIT(_g->ni241_suif_tmp3,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni241_suif_tmp3,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b7s3;
    }
    break;
  case stateType_b8s0:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b9s0:
    if (BIT(_g->ni244_suif_tmp4,0-0) == 1) {
      _g->nextState=stateType_b10s0;
    } else if ((!BIT(_g->ni244_suif_tmp4,0-0)) == 1) {
      _g->nextState=stateType_b11s0;
    } else  {
      _g->nextState=stateType_b9s0;
    }
    break;
  case stateType_b10s0:
    _g->nextState=stateType_b11s0;
    break;
  case stateType_b11s0:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b12s0:
    _g->nextState=stateType_finished;
    break;
  case stateType_finished:
    _g->nextState=stateType_finished;
    break;
  default:
    _g->nextState=stateType_init;
    break;
  }
  _g->fadd_ll_0_value=(unsigned int ) fadd(_g->r_nResultScore,_g->r_nHitScore);
  _g->flteq_ll_1_value=(((flteq(_g->r_threshold,_g->r_nHitScore))>>(0-2147483647))&0x1);
  if (_g->thisState == stateType_b7s0 && _g->stateEn == 1) {
    _g->ti137_req=1;
  } else  {
    _g->ti137_req=0;
  }
  if (_g->thisState == stateType_b6s0 && _g->stateEn == 1) {
    _g->ti132_req=1;
  } else  {
    _g->ti132_req=0;
  }
  if (_g->thisState == stateType_b11s0) {
    _g->p_score_stream_eos=1;
  } else  {
    _g->p_score_stream_eos=0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_score_stream_data=_g->ni243_nResultScore;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_score_stream_data=_g->r_nResultScore;
  } else  {
    _g->p_score_stream_data=0x0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else  {
    _g->p_score_stream_en=0;
  }
  if (_g->thisState == stateType_b11s0) {
    _g->p_start_stream_eos=1;
  } else  {
    _g->p_start_stream_eos=0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_start_stream_data=_g->ni242_nResultStart;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_start_stream_data=_g->r_nResultStart;
  } else  {
    _g->p_start_stream_data=0x0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else  {
    _g->p_start_stream_en=0;
  }
}

static void clk_proc(Filter_rtl_t *_g)

{

  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti137_pipeen == 1) {
      _g->flteq_ll_1_queue_mem[(_g->flteq_ll_1_queue_in_ptr)-0]=_g->flteq_ll_1_value;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti132_pipeen == 1) {
      _g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_in_ptr)-0]=_g->fadd_ll_0_value;
    }
  }
  if (_g->reset == 1) {
    _g->newState=1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    _g->newState=_g->stateEn;
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b0s0:
      if (_g->stateEn == 1) {
        _g->r_r_e_g_0=_g->ni75_r_e_g_0;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b0s1:
      if (_g->stateEn == 1) {
        _g->r_threshold=_g->ni230_threshold;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b0s1:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp=_g->ni229_suif_tmp;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b1s0:
      if (_g->stateEn == 1) {
        _g->r_filterMode=_g->ni231_filterMode;
      }
      break;
    case stateType_b2s0:
      if (_g->stateEn == 1) {
        _g->r_filterMode=_g->ni232_filterMode;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b3s0:
      if (_g->stateEn == 1) {
        _g->r_nResultStart=_g->ni233_nResultStart;
      }
      break;
    case stateType_b8s0:
      if (_g->stateEn == 1) {
        _g->r_nResultStart=_g->ni242_nResultStart;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b3s0:
      if (_g->stateEn == 1) {
        _g->r_nResultScore=_g->ni234_nResultScore;
      }
      break;
    case stateType_b6s3:
      if (_g->stateEn == 1) {
        _g->r_nResultScore=_g->ni240_nResultScore;
      }
      break;
    case stateType_b8s0:
      if (_g->stateEn == 1) {
        _g->r_nResultScore=_g->ni243_nResultScore;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp0=_g->ni235_suif_tmp0;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s1:
      if (_g->stateEn == 1) {
        _g->r_nHitStart=_g->ni236_nHitStart;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s1:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp1=_g->ni237_suif_tmp1;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b4s2:
      if (_g->stateEn == 1) {
        _g->r_nHitScore=_g->ni238_nHitScore;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b5s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp2=_g->ni239_suif_tmp2;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b7s3:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp3=_g->ni241_suif_tmp3;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    switch (_g->thisState) {
    case stateType_b9s0:
      if (_g->stateEn == 1) {
        _g->r_suif_tmp4=_g->ni244_suif_tmp4;
      }
      break;
    default:
      break;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_threshold_stream_en & _g->p_threshold_stream_rdy) == 1) {
      _g->r_threshold_stream=_g->p_threshold_stream_data;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_counter_stream_en & _g->p_counter_stream_rdy) == 1) {
      _g->r_counter_stream=_g->p_counter_stream_data;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if ((_g->p_sum_stream_en & _g->p_sum_stream_rdy) == 1) {
      _g->r_sum_stream=_g->p_sum_stream_data;
    }
  }
  if (_g->reset == 1) {
    _g->thisState=stateType_init;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->stateEn == 1) {
      _g->thisState=_g->nextState;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti132_pipeen == 1) {
      _g->fadd_ll_0_queue_in_ptr=_g->fadd_ll_0_queue_next_ptr;
    }
  }
  if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->ti137_pipeen == 1) {
      _g->flteq_ll_1_queue_in_ptr=_g->flteq_ll_1_queue_next_ptr;
    }
  }
}

static void init_proc(Filter_rtl_t *_g)

{

  _g->ni231_filterMode=0x1;
  _g->ni232_filterMode=0x2;
  _g->ni233_nResultStart=0x0;
  _g->ni234_nResultScore=0x0;
  if ((_g->flteq_ll_1_queue_in_ptr) < 3) {
    _g->flteq_ll_1_queue_next_ptr=(((_g->flteq_ll_1_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->flteq_ll_1_queue_next_ptr=0x0;
  }
  _g->flteq_ll_1_queue_out_ptr=_g->flteq_ll_1_queue_next_ptr;
  _g->t_1=_g->flteq_ll_1_queue_mem[(_g->flteq_ll_1_queue_out_ptr)-0];
  _g->ni229_suif_tmp=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|_g->r_r_e_g_0) != 0x0));
  _g->ni235_suif_tmp0=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_counter_stream_eos)) == 0x0));
  _g->ni239_suif_tmp2=(((unsigned int)0x0<<1)|(unsigned int)((((_g->r_filterMode)>>(0-0))&0x7) == 0x1));
  _g->ni241_suif_tmp3=(((unsigned int)0x0<<1)|(unsigned int)_g->t_1);
  _g->ni244_suif_tmp4=(((unsigned int)0x0<<1)|(unsigned int)((((_g->r_filterMode)>>(0-0))&0x7) == 0x1));
  switch (_g->thisState) {
  case stateType_init:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b0s0:
    _g->nextState=stateType_b0s1;
    break;
  case stateType_b0s1:
    if (BIT(_g->ni229_suif_tmp,0-0) == 1) {
      _g->nextState=stateType_b1s0;
    } else if ((!BIT(_g->ni229_suif_tmp,0-0)) == 1) {
      _g->nextState=stateType_b2s0;
    } else  {
      _g->nextState=stateType_b0s1;
    }
    break;
  case stateType_b1s0:
    _g->nextState=stateType_b3s0;
    break;
  case stateType_b2s0:
    _g->nextState=stateType_b3s0;
    break;
  case stateType_b3s0:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b4s0:
    if ((!BIT(_g->ni235_suif_tmp0,0-0)) == 1) {
      _g->nextState=stateType_b9s0;
    } else  {
      _g->nextState=stateType_b4s1;
    }
    break;
  case stateType_b4s1:
    _g->nextState=stateType_b4s2;
    break;
  case stateType_b4s2:
    if (BIT(_g->r_suif_tmp1,0-0) == 1) {
      _g->nextState=stateType_b5s0;
    } else if ((!BIT(_g->r_suif_tmp1,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b4s2;
    }
    break;
  case stateType_b5s0:
    if (BIT(_g->ni239_suif_tmp2,0-0) == 1) {
      _g->nextState=stateType_b6s0;
    } else if ((!BIT(_g->ni239_suif_tmp2,0-0)) == 1) {
      _g->nextState=stateType_b7s0;
    } else  {
      _g->nextState=stateType_b5s0;
    }
    break;
  case stateType_b6s0:
    _g->nextState=stateType_b6s1;
    break;
  case stateType_b6s1:
    _g->nextState=stateType_b6s2;
    break;
  case stateType_b6s2:
    _g->nextState=stateType_b6s3;
    break;
  case stateType_b6s3:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b7s0:
    _g->nextState=stateType_b7s1;
    break;
  case stateType_b7s1:
    _g->nextState=stateType_b7s2;
    break;
  case stateType_b7s2:
    _g->nextState=stateType_b7s3;
    break;
  case stateType_b7s3:
    if (BIT(_g->ni241_suif_tmp3,0-0) == 1) {
      _g->nextState=stateType_b8s0;
    } else if ((!BIT(_g->ni241_suif_tmp3,0-0)) == 1) {
      _g->nextState=stateType_b4s0;
    } else  {
      _g->nextState=stateType_b7s3;
    }
    break;
  case stateType_b8s0:
    _g->nextState=stateType_b4s0;
    break;
  case stateType_b9s0:
    if (BIT(_g->ni244_suif_tmp4,0-0) == 1) {
      _g->nextState=stateType_b10s0;
    } else if ((!BIT(_g->ni244_suif_tmp4,0-0)) == 1) {
      _g->nextState=stateType_b11s0;
    } else  {
      _g->nextState=stateType_b9s0;
    }
    break;
  case stateType_b10s0:
    _g->nextState=stateType_b11s0;
    break;
  case stateType_b11s0:
    _g->nextState=stateType_b0s0;
    break;
  case stateType_b12s0:
    _g->nextState=stateType_finished;
    break;
  case stateType_finished:
    _g->nextState=stateType_finished;
    break;
  default:
    _g->nextState=stateType_init;
    break;
  }
  if (_g->thisState == stateType_b0s0 && _g->p_threshold_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s0 && _g->p_counter_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b4s1 && _g->p_sum_stream_rdy == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b8s0 && (_g->p_start_stream_rdy & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b10s0 && (_g->p_start_stream_rdy & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else if (_g->thisState == stateType_b11s0 && ((((_g->p_threshold_stream_eos & _g->p_counter_stream_eos) & _g->p_sum_stream_eos) & _g->p_start_stream_rdy) & _g->p_score_stream_rdy) == 0) {
    _g->stateEn=0;
  } else  {
    _g->stateEn=1;
  }
  if ((_g->fadd_ll_0_queue_in_ptr) < 3) {
    _g->fadd_ll_0_queue_next_ptr=(((_g->fadd_ll_0_queue_in_ptr + 1)))&0x7;
  } else  {
    _g->fadd_ll_0_queue_next_ptr=0x0;
  }
  _g->fadd_ll_0_queue_out_ptr=_g->fadd_ll_0_queue_next_ptr;
  _g->t_0=_g->fadd_ll_0_queue_mem[(_g->fadd_ll_0_queue_out_ptr)-0];
  _g->ni242_nResultStart=_g->r_nHitStart;
  _g->ni243_nResultScore=_g->r_nHitScore;
  if (_g->stateEn == 1) {
    _g->ti137_pipeen=1;
  } else  {
    _g->ti137_pipeen=0;
  }
  if (_g->thisState == stateType_b7s0 && _g->stateEn == 1) {
    _g->ti137_req=1;
  } else  {
    _g->ti137_req=0;
  }
  if (_g->stateEn == 1) {
    _g->ti132_pipeen=1;
  } else  {
    _g->ti132_pipeen=0;
  }
  if (_g->thisState == stateType_b6s0 && _g->stateEn == 1) {
    _g->ti132_req=1;
  } else  {
    _g->ti132_req=0;
  }
  if (_g->thisState == stateType_b11s0) {
    _g->p_score_stream_eos=1;
  } else  {
    _g->p_score_stream_eos=0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_score_stream_data=_g->ni243_nResultScore;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_score_stream_data=_g->r_nResultScore;
  } else  {
    _g->p_score_stream_data=0x0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_score_stream_en=_g->stateEn;
  } else  {
    _g->p_score_stream_en=0;
  }
  if (_g->thisState == stateType_b11s0) {
    _g->p_start_stream_eos=1;
  } else  {
    _g->p_start_stream_eos=0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_start_stream_data=_g->ni242_nResultStart;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_start_stream_data=_g->r_nResultStart;
  } else  {
    _g->p_start_stream_data=0x0;
  }
  if (_g->thisState == stateType_b8s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b10s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_start_stream_en=_g->stateEn;
  } else  {
    _g->p_start_stream_en=0;
  }
  if (_g->thisState == stateType_b4s1) {
    _g->p_sum_stream_en=(_g->stateEn & (!_g->p_sum_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_sum_stream_en=_g->stateEn;
  } else  {
    _g->p_sum_stream_en=0;
  }
  if (_g->thisState == stateType_b4s0) {
    _g->p_counter_stream_en=(_g->stateEn & (!_g->p_counter_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_counter_stream_en=_g->stateEn;
  } else  {
    _g->p_counter_stream_en=0;
  }
  if (_g->thisState == stateType_b0s0) {
    _g->p_threshold_stream_en=(_g->stateEn & (!_g->p_threshold_stream_eos));
  } else if (_g->thisState == stateType_b11s0) {
    _g->p_threshold_stream_en=_g->stateEn;
  } else  {
    _g->p_threshold_stream_en=0;
  }
  _g->ni240_nResultScore=_g->t_0;
  _g->ni238_nHitScore=_g->r_sum_stream;
  _g->ni237_suif_tmp1=(((unsigned int)0x0<<1)|(unsigned int)(((0x0<<1)|mkvec(_g->p_sum_stream_eos)) == 0x0));
  _g->ni236_nHitStart=_g->r_counter_stream;
  _g->ni230_threshold=_g->r_threshold_stream;
  _g->ni75_r_e_g_0=mkvec(_g->p_threshold_stream_eos);
  _g->fadd_ll_0_value=(unsigned int ) fadd(_g->r_nResultScore,_g->r_nHitScore);
  _g->flteq_ll_1_value=(((flteq(_g->r_threshold,_g->r_nHitScore))>>(0-2147483647))&0x1);
  if (_g->reset == 1) {
    _g->thisState=stateType_init;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    if (_g->stateEn == 1) {
      _g->thisState=_g->nextState;
    }
  }
  if (_g->reset == 1) {
    _g->newState=1;
  } else if (_g->_sd_clk.event && _g->clk == 1) {
    _g->newState=_g->stateEn;
  }
}

Filter_rtl_if_t *create_Filter_rtl()

{
  Filter_rtl_if_t *ret;
  Filter_rtl_t *_g;
  ret=(Filter_rtl_if_t *)malloc(sizeof(Filter_rtl_if_t));
  ret->clk_deltap=clk_delta;
  ret->clk_procp=clk_proc;
  ret->init_procp=init_proc;
  ret->endp=_end_cycle;
  ret->data=_g=(Filter_rtl_t *)malloc(sizeof(Filter_rtl_t));
  memset(ret->data,0,sizeof(Filter_rtl_t));
  ;
  _g->fadd_ll_0_queue_mem[0]=128;
  ;
  return(ret);
}

void enum_Filter_rtl(void (*enump)(), void *arg)
{
  (*enump)(arg,"reset",offsetof(Filter_rtl_t,reset),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_reset",offsetof(Filter_rtl_t,_sd_reset),sizeof(struct _sd_reset_s),1);
  (*enump)(arg,"sclk",offsetof(Filter_rtl_t,sclk),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_sclk",offsetof(Filter_rtl_t,_sd_sclk),sizeof(struct _sd_sclk_s),1);
  (*enump)(arg,"clk",offsetof(Filter_rtl_t,clk),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_clk",offsetof(Filter_rtl_t,_sd_clk),sizeof(struct _sd_clk_s),1);
  (*enump)(arg,"p_threshold_stream_rdy",offsetof(Filter_rtl_t,p_threshold_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_threshold_stream_rdy",offsetof(Filter_rtl_t,_sd_p_threshold_stream_rdy),sizeof(struct _sd_p_threshold_stream_rdy_s),1);
  (*enump)(arg,"p_threshold_stream_en",offsetof(Filter_rtl_t,p_threshold_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_threshold_stream_en",offsetof(Filter_rtl_t,_sd_p_threshold_stream_en),sizeof(struct _sd_p_threshold_stream_en_s),1);
  (*enump)(arg,"p_threshold_stream_eos",offsetof(Filter_rtl_t,p_threshold_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_threshold_stream_eos",offsetof(Filter_rtl_t,_sd_p_threshold_stream_eos),sizeof(struct _sd_p_threshold_stream_eos_s),1);
  (*enump)(arg,"p_threshold_stream_data",offsetof(Filter_rtl_t,p_threshold_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_threshold_stream_data",offsetof(Filter_rtl_t,_sd_p_threshold_stream_data),sizeof(struct _sd_p_threshold_stream_data_s),1);
  (*enump)(arg,"p_counter_stream_rdy",offsetof(Filter_rtl_t,p_counter_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_rdy",offsetof(Filter_rtl_t,_sd_p_counter_stream_rdy),sizeof(struct _sd_p_counter_stream_rdy_s),1);
  (*enump)(arg,"p_counter_stream_en",offsetof(Filter_rtl_t,p_counter_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_en",offsetof(Filter_rtl_t,_sd_p_counter_stream_en),sizeof(struct _sd_p_counter_stream_en_s),1);
  (*enump)(arg,"p_counter_stream_eos",offsetof(Filter_rtl_t,p_counter_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_counter_stream_eos",offsetof(Filter_rtl_t,_sd_p_counter_stream_eos),sizeof(struct _sd_p_counter_stream_eos_s),1);
  (*enump)(arg,"p_counter_stream_data",offsetof(Filter_rtl_t,p_counter_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_counter_stream_data",offsetof(Filter_rtl_t,_sd_p_counter_stream_data),sizeof(struct _sd_p_counter_stream_data_s),1);
  (*enump)(arg,"p_sum_stream_rdy",offsetof(Filter_rtl_t,p_sum_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_rdy",offsetof(Filter_rtl_t,_sd_p_sum_stream_rdy),sizeof(struct _sd_p_sum_stream_rdy_s),1);
  (*enump)(arg,"p_sum_stream_en",offsetof(Filter_rtl_t,p_sum_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_en",offsetof(Filter_rtl_t,_sd_p_sum_stream_en),sizeof(struct _sd_p_sum_stream_en_s),1);
  (*enump)(arg,"p_sum_stream_eos",offsetof(Filter_rtl_t,p_sum_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_sum_stream_eos",offsetof(Filter_rtl_t,_sd_p_sum_stream_eos),sizeof(struct _sd_p_sum_stream_eos_s),1);
  (*enump)(arg,"p_sum_stream_data",offsetof(Filter_rtl_t,p_sum_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_sum_stream_data",offsetof(Filter_rtl_t,_sd_p_sum_stream_data),sizeof(struct _sd_p_sum_stream_data_s),1);
  (*enump)(arg,"p_start_stream_rdy",offsetof(Filter_rtl_t,p_start_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_start_stream_rdy",offsetof(Filter_rtl_t,_sd_p_start_stream_rdy),sizeof(struct _sd_p_start_stream_rdy_s),1);
  (*enump)(arg,"p_start_stream_en",offsetof(Filter_rtl_t,p_start_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_start_stream_en",offsetof(Filter_rtl_t,_sd_p_start_stream_en),sizeof(struct _sd_p_start_stream_en_s),1);
  (*enump)(arg,"p_start_stream_eos",offsetof(Filter_rtl_t,p_start_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_start_stream_eos",offsetof(Filter_rtl_t,_sd_p_start_stream_eos),sizeof(struct _sd_p_start_stream_eos_s),1);
  (*enump)(arg,"p_start_stream_data",offsetof(Filter_rtl_t,p_start_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_start_stream_data",offsetof(Filter_rtl_t,_sd_p_start_stream_data),sizeof(struct _sd_p_start_stream_data_s),1);
  (*enump)(arg,"p_score_stream_rdy",offsetof(Filter_rtl_t,p_score_stream_rdy),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_score_stream_rdy",offsetof(Filter_rtl_t,_sd_p_score_stream_rdy),sizeof(struct _sd_p_score_stream_rdy_s),1);
  (*enump)(arg,"p_score_stream_en",offsetof(Filter_rtl_t,p_score_stream_en),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_score_stream_en",offsetof(Filter_rtl_t,_sd_p_score_stream_en),sizeof(struct _sd_p_score_stream_en_s),1);
  (*enump)(arg,"p_score_stream_eos",offsetof(Filter_rtl_t,p_score_stream_eos),sizeof(unsigned char ),1);
  (*enump)(arg,"_sd_p_score_stream_eos",offsetof(Filter_rtl_t,_sd_p_score_stream_eos),sizeof(struct _sd_p_score_stream_eos_s),1);
  (*enump)(arg,"p_score_stream_data",offsetof(Filter_rtl_t,p_score_stream_data),sizeof(unsigned int ),1);
  (*enump)(arg,"_sd_p_score_stream_data",offsetof(Filter_rtl_t,_sd_p_score_stream_data),sizeof(struct _sd_p_score_stream_data_s),1);
  (*enump)(arg,"flteq_ll_1_queue_mem",offsetof(Filter_rtl_t,flteq_ll_1_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"flteq_ll_1_queue_in_ptr",offsetof(Filter_rtl_t,flteq_ll_1_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"flteq_ll_1_queue_out_ptr",offsetof(Filter_rtl_t,flteq_ll_1_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"flteq_ll_1_queue_next_ptr",offsetof(Filter_rtl_t,flteq_ll_1_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"flteq_ll_1_value",offsetof(Filter_rtl_t,flteq_ll_1_value),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_mem",offsetof(Filter_rtl_t,fadd_ll_0_queue_mem),sizeof(unsigned int [4]),0);
  (*enump)(arg,"fadd_ll_0_queue_in_ptr",offsetof(Filter_rtl_t,fadd_ll_0_queue_in_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_out_ptr",offsetof(Filter_rtl_t,fadd_ll_0_queue_out_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_queue_next_ptr",offsetof(Filter_rtl_t,fadd_ll_0_queue_next_ptr),sizeof(unsigned int ),0);
  (*enump)(arg,"fadd_ll_0_value",offsetof(Filter_rtl_t,fadd_ll_0_value),sizeof(unsigned int ),0);
  (*enump)(arg,"thisState",offsetof(Filter_rtl_t,thisState),sizeof(enum stateType ),0);
  (*enump)(arg,"nextState",offsetof(Filter_rtl_t,nextState),sizeof(enum stateType ),0);
  (*enump)(arg,"stateEn",offsetof(Filter_rtl_t,stateEn),sizeof(unsigned char ),0);
  (*enump)(arg,"newState",offsetof(Filter_rtl_t,newState),sizeof(unsigned char ),0);
  (*enump)(arg,"r_threshold_stream",offsetof(Filter_rtl_t,r_threshold_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_counter_stream",offsetof(Filter_rtl_t,r_counter_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_sum_stream",offsetof(Filter_rtl_t,r_sum_stream),sizeof(unsigned int ),0);
  (*enump)(arg,"r_threshold",offsetof(Filter_rtl_t,r_threshold),sizeof(unsigned int ),0);
  (*enump)(arg,"ni230_threshold",offsetof(Filter_rtl_t,ni230_threshold),sizeof(unsigned int ),0);
  (*enump)(arg,"r_filterMode",offsetof(Filter_rtl_t,r_filterMode),sizeof(unsigned int ),0);
  (*enump)(arg,"ni231_filterMode",offsetof(Filter_rtl_t,ni231_filterMode),sizeof(unsigned int ),0);
  (*enump)(arg,"ni232_filterMode",offsetof(Filter_rtl_t,ni232_filterMode),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nResultStart",offsetof(Filter_rtl_t,r_nResultStart),sizeof(unsigned int ),0);
  (*enump)(arg,"ni233_nResultStart",offsetof(Filter_rtl_t,ni233_nResultStart),sizeof(unsigned int ),0);
  (*enump)(arg,"ni242_nResultStart",offsetof(Filter_rtl_t,ni242_nResultStart),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nResultScore",offsetof(Filter_rtl_t,r_nResultScore),sizeof(unsigned int ),0);
  (*enump)(arg,"ni234_nResultScore",offsetof(Filter_rtl_t,ni234_nResultScore),sizeof(unsigned int ),0);
  (*enump)(arg,"ni240_nResultScore",offsetof(Filter_rtl_t,ni240_nResultScore),sizeof(unsigned int ),0);
  (*enump)(arg,"ni243_nResultScore",offsetof(Filter_rtl_t,ni243_nResultScore),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nHitStart",offsetof(Filter_rtl_t,r_nHitStart),sizeof(unsigned int ),0);
  (*enump)(arg,"ni236_nHitStart",offsetof(Filter_rtl_t,ni236_nHitStart),sizeof(unsigned int ),0);
  (*enump)(arg,"r_nHitScore",offsetof(Filter_rtl_t,r_nHitScore),sizeof(unsigned int ),0);
  (*enump)(arg,"ni238_nHitScore",offsetof(Filter_rtl_t,ni238_nHitScore),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp",offsetof(Filter_rtl_t,r_suif_tmp),sizeof(unsigned int ),0);
  (*enump)(arg,"ni229_suif_tmp",offsetof(Filter_rtl_t,ni229_suif_tmp),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp0",offsetof(Filter_rtl_t,r_suif_tmp0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni235_suif_tmp0",offsetof(Filter_rtl_t,ni235_suif_tmp0),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp1",offsetof(Filter_rtl_t,r_suif_tmp1),sizeof(unsigned int ),0);
  (*enump)(arg,"ni237_suif_tmp1",offsetof(Filter_rtl_t,ni237_suif_tmp1),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp2",offsetof(Filter_rtl_t,r_suif_tmp2),sizeof(unsigned int ),0);
  (*enump)(arg,"ni239_suif_tmp2",offsetof(Filter_rtl_t,ni239_suif_tmp2),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp3",offsetof(Filter_rtl_t,r_suif_tmp3),sizeof(unsigned int ),0);
  (*enump)(arg,"ni241_suif_tmp3",offsetof(Filter_rtl_t,ni241_suif_tmp3),sizeof(unsigned int ),0);
  (*enump)(arg,"r_suif_tmp4",offsetof(Filter_rtl_t,r_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"ni244_suif_tmp4",offsetof(Filter_rtl_t,ni244_suif_tmp4),sizeof(unsigned int ),0);
  (*enump)(arg,"r_r_e_g_0",offsetof(Filter_rtl_t,r_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"ni75_r_e_g_0",offsetof(Filter_rtl_t,ni75_r_e_g_0),sizeof(unsigned int ),0);
  (*enump)(arg,"ti137_pipeen",offsetof(Filter_rtl_t,ti137_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti137_req",offsetof(Filter_rtl_t,ti137_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_1",offsetof(Filter_rtl_t,t_1),sizeof(unsigned int ),0);
  (*enump)(arg,"ti132_pipeen",offsetof(Filter_rtl_t,ti132_pipeen),sizeof(unsigned char ),0);
  (*enump)(arg,"ti132_req",offsetof(Filter_rtl_t,ti132_req),sizeof(unsigned char ),0);
  (*enump)(arg,"t_0",offsetof(Filter_rtl_t,t_0),sizeof(unsigned int ),0);
}

static unsigned int mkvec(unsigned char b_2)
{
  unsigned int res=0x0;

  res=res&~MKBIT(1,0-0)|MKBIT(b_2,0-0);
  return(res);
}

